package Simusol::PlotGNU;
use strict;
use warnings;
use Data::Dumper;

use Simusol::AyudasPP;
use Getopt::Long;
use Pod::Usage;
use Text::Abbrev;
use Capture::Tiny ':all';

use Path::Class;  # ver de sacar o no
use Cwd;
# cambiar a esta clase todo lo relativo a directoirios
#my $file = file('foo', 'bar.txt');
#my $dir = $file->parent;
#    my $file2 = file('foo','si','baro.txt');
#my $dir2 = $file2->parent;
#my $file3 = file('auello','si','baro2.txt');
#my $dir3 = $file3->parent;

#$rel = $dir3->relative($dir);

#print "$dir, $dir2, $dir3, $rel\n";

#exit;
#if ($file->is_absolute) { }
#$file->components;
#$file->slurp();
#$file->spew( $content );
#$file->remove();
#$file->cleanup; # Perform logical cleanup of pathname
#$file->resolve; # Perform physical cleanup of pathname
#my $dir = dir('foo', 'bar');  

my %dirsalida;

#our %unist;

#print STDERR "Estoy en $progname @ARGV\n";
our %reserv_dir;


our $avisosgrav;
#our $archivosinext;


#our $LSS1;

our $refnombreshashes; 
# key nombre de variable propia; valor orden de la var. (empieza con 1)
our $refsceptrehashes; #similar para nombres sceptre
our $archivopadre; #key nombre simbolico de archivo; para variaciones y selec
#  valor nombre simbolico de archivo con igual estructura de variables etc.
# si no hay otro no estara definido 
   

our $datosPlotGNU={};


# los primeros siguientes, con  nombre simbolico de archivo como key 

our ( %nombarch, %exiarch, %reffactor
     , %refvarori
     , %SIMBOARCHORI, %uniabsc, %uniord, %varabsc, %magord
     ,%marca, %unipri
      , %refparap, %refarch);


# los ultimos anteriores, con nombre de grafo como key:  
# %refind permite pasar de indice de var. propia a indice de sceptre 

our (%mj, %rx, %ry, %selec, %fun, %titfun, %todo 
     ,%exigraf, %simbografori
    ,%titx,%tity
    , %titulograf, %usaarchivos,
    ,%usagraf_coma_arch_cols  
    ,%uniabscisa, %uniordenadas, %prig, %segg
     ,%juntos);

our %mensajegra; 
our %nomostrar;
our @mostrarjunto; 

#our $archi;# para que pueda nombrarse como ejemplo
#our $panta0;
#our  @separadores;
#our $pwdori;


# -----------------------------------------------------------------------------
sub inicio{ # se ejecuta al comienzo del uso del modulo por el programa
    # carga los datos estaticos comunes del modulo;
    # si fuese necesario cambiarlos se podrian leer de un archivo de configuracion
    
    $datosPlotGNU->{term}={'eps' => 'postscript eps', 
                           'png' => 'png'};

    # NO SE USA, es para que se pueda
    #print  "MMMMMMMM ", keys %{$datosPlotGNU->{term}};
    $datosPlotGNU->{gterm}=[sort keys %{$datosPlotGNU->{term}}];
   
    my $uni={};
    abbrev $uni, qw(minutos horas segundos dias);
    $datosPlotGNU->{unist}=$uni;
    #lo anterior define un hash con key: abreviatura y value los dados;
    # ejemplo: $unis{se} vale segundos; $unis{'aab'} esta indefinido
    #print Dumper $datosPlotGNU->{unist};

    $datosPlotGNU->{factort}={'segundos' => 1, 'minutos' => 60, 'horas' => 3600, 
                              'dias' => 86400, 'hour'=>3600},
    
    # $LSS1={};
    # $LSS1->{YYY}=["III"]; 
}

##############

sub iniarch{  #se ejecuta cada vez que se va a procesar un nuevo archivo
    %mensajegra=();
    %nomostrar = ();
    @mostrarjunto = (); 
    %dirsalida=();

    %nombarch=();
    %exiarch=();
    %reffactor=();
    %refvarori=();
    %SIMBOARCHORI=();
    %uniabsc=();
    %uniord=();
    %varabsc=();
    %magord=();
    %marca=();
    %unipri=();
    %refparap=();
    %refarch=();

    %selec=();

    %mj=(); %rx=(); %ry=(); %selec=(); %fun=(); %titfun=();  %todo =();

    %exigraf=(); 
    %simbografori    =();
    %titx=();
    %tity=();

    %titulograf=(); 
    %usaarchivos=();

    %usagraf_coma_arch_cols      =();
    %uniabscisa=(); 
    %uniordenadas=(); 
    %prig=(); 
    %segg =();
    %juntos =();
    
}

################################################################################################################
sub gnuplot{
    my ($renglones,$elemento,$archivos,$reruns,$noverb,$graff,$nograffile,$mensaje_comienzo)=@_;

    iniarch();

    my $noclas=$archivos->{noclas};

    #pedidos concretos de elementos de grafos
    # habrá que incorporar otras unidades
    # se necesitan los apóstrofes para el gnuplot

    #    chdir $BASEARCH;
    #al haber canbiado de directorio solo interesaran,,
    # desde aqui, $PROPIO Y $Simusol::PlotGNU::PROPIOSINDIA; para los errores ...

    # vaya a saber adonde van las gra!! los gnu los eps o png!!!!!  
    #    system "rm $arch.gra 2>/dev/null";

    # no uso gnus  
    #  -e 'gnus' or crear_gnus('./');
    #  -d 'gnus' and -w 'gnus' or die "Necesito trabajar con directorio gnus\n"; 
    
    ###########################################################################################
    #$Simusol::PlotGNU::PROPIOASINDIA

    #moderno file: $dirsal{paraplot}$propiosin.paraplot

    my ($archivo,$dirarchivo,$bn)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.gra','');
    Simusol::AyudasPP::creacamino($dirarchivo,$archivos,$elemento,0);

    #print "ARCHIVO GRA $archivo\n";
       
    $archivos->{arg}->{$elemento}->{gra}->{archivo}=$archivo;
    $archivos->{arg}->{$elemento}->{gra}->{dirarchivo}="$dirarchivo";

    my $plf={};

    my $pun_lin={};
    my $nombrearch={};


    
    my ($ok, $lisarchsimul,$guardar_graf)=leer_paraplot3($renglones,
                                                    $elemento,$archivos,$noclas,$plf,$pun_lin,$nombrearch,$graff); 

    if ($ok != 1){ return ($ok)}
    #si hay $paraplot de ahi, si no de archivo paraplot



    impr_debug(__LINE__.' sim3 %Simusol::PlotGNU::exigraf',\%Simusol::PlotGNU::exigraf);
    impr_debug(__LINE__.' sim3 %Simusol::PlotGNU::marca',Dumper \%Simusol::PlotGNU::marca);
    my ($archivogra,$Xarchivosgra,$paraarchivos,$paraver,$losgnu);
    #print "GRAF $graff ", Dumper \%Simusol::PlotGNU::exigraf;
  
    #   if ($graff == 1  or ($graff and  scalar (keys %Simusol::PlotGNU::exigraf) == 0)) {
    # se quita la opcion de que funcione interactivo si no hay graficas!!!
    # si se esta en un script y no hay graficos se para todo, la vida debe continuar y salir de los errores
    # solo va a interactivo si se pide explicitamente
    # lo interactivo es algo raro, especial y debe ser pedido
    if ($graff == 1 ) {
 
        $graff = 1; #die;
        ($archivogra,$Xarchivosgra,$paraarchivos,$paraver,$losgnu,$guardar_graf)=Simusol::PlotGNU::graficar_interact($guardar_graf,$archivos,$elemento,$plf,$pun_lin,$nombrearch,$noverb,$graff,$mensaje_comienzo,$nograffile,$dirarchivo);
        # gráficos interactivos (a pedido o por falta de pedidos concretos)
    } else {
    #contr_jun() if scalar keys %juntos;

    # print Dumper $pun_lin;
    Simusol::PlotGNU::contr($plf,$pun_lin);


  
    
    #
    # exit;    
    # Si no hubo nada para graficar, contr hizo parar3  
    
    
    ($archivogra,$Xarchivosgra,$paraarchivos,$paraver,$losgnu)=Simusol::PlotGNU::graficar_pedidos($archivos,$elemento,\%exigraf,\%mensajegra,\%nomostrar,$lisarchsimul,$reruns,$guardar_graf,$archivo,$dirarchivo,$plf,$pun_lin,$nombrearch,$noverb,$graff,$mensaje_comienzo,$nograffile);
    }

    #print "paraarchivos $paraarchivos paraver $paraver GRA $archivogra KGRA $Xarchivosgra los GNU ", Dumper $losgnu;
    return (1,$archivogra,$Xarchivosgra,$paraarchivos,$paraver,$losgnu);
    
    ### SI NO SE QUISIESE ESCRIBIR LOS GRA Y DIRECTAMENTE EJECUTAR GNUPLOT!!!!!??????

}

################################################################


sub ejecutagra{
	my ($archivogra,$Xarchivosgra,$paraver,$losgnu,$archivos,$elemento)=@_;
    my $dirgra=file($archivogra)->dir;
    #print "DIRGRA $dirgra\n";

    
    use Path::Class;  # ver de sacar o no  
    #print "GRAF $commlineinfo->{opciones}->{graf}\n";
  
      if ($paraver){
	  foreach my $r (split(/\n/,$paraver)){
	     my $rr=$r;
             $rr=~s/ NULL$// ;
	     #print "XX $rr XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx  \n";
	     # ver de buscar en archivos ya resuelto el dir
             my $basen=file($rr)->basename;
	     $basen=~s/\.gnu$//;
	     
             my ($archiG,$camino6,$x5)     =Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.gnu',$basen);
	     #rint "ARCHIG $archiG\n";
	     # Simusol::AyudasPP::archiva($archiG,'F',$archivos,$elemento);
	     # quizas ya esta, no se si siempre los crea
	      Simusol::AyudasPP::creacamino($camino6,$archiG,$elemento,0);
             ejecutar_graf_sa($losgnu->{$archiG},$r,$dirgra);	     
             }
	
      }elsif($archivogra and -e $archivogra){
             ejecutar_graf($archivogra,$Xarchivosgra,$archivos,$elemento);                  
             }
    
      
    }
##############################################################
sub ejecutar_graf_sa{
    my ($TEXTO,$file,$dir)=@_;
             #my $ofile=$file;
             my $pers='-persist';
	     my $null='';
	     if ($file=~s/ NULL$//){
		$pers='';
		$null='>/dev/null';
	        }
 	     #    system("gnuplot ".$file) ;
	     
	     if (not $TEXTO or not defined $TEXTO){
                 warn "ERROR: falta TEXTO, para losgnu->{$file}"; 
	     }else{
		 $TEXTO=~s/\#[^\n]*\n//g;
		 $TEXTO=~s/([^\\])\n/$1;/g;
  	         $TEXTO=~s/\$/\\\$/g;
		 ################################################# PONER FORK
                 #system("gnuplot $pers -e \"$TEXTO\" $null") ;

		 #print "XXXXXXXX cd $dir; gnuplot $pers -e \"$TEXTO\" $null";
		
       my ($stdout, $stderr, $errorcod)=capture {          
         my $pid;
         $pid = fork();
         if (not defined $pid) {
             warn "Recursos indisponibles para fork.\n";
         }elsif ($pid == 0) {
          #print "Proceso hijo para graficar\n";
          #system "firefox http://localhost:$port";
          system("cd $dir; gnuplot $pers -e \"$TEXTO\" $null") ;
          
          exit(0);
          }
        };           
	print $stdout;
	#warn $stderr;  # da warnings no se que son
	
 
  
	     }	 
	         #print "ZZZ $file --- gnuplot $pers -e \"$TEXTO\" $null\n";
             
}

##############################################################
sub graficosimul{
    my  ($ordenfijo,$archsal,$time,$imprime)=@_;

    #print "XXXXXXXXXXXXXXXXXXXX archsal  $archsal imprime @$imprime\n";
    my $pos;
    my $npos=0;
    my @ooo=('step',@$ordenfijo);
    #print "ordenfijo: @ooo\n";
    foreach (@ooo){
	#print "POS $_ $npos\n";
	$pos->{$_}=$npos++;

    }
     if (not defined $pos->{$time}){
	warn "ERROR variable ordenada time $time  no definida\n";
        exit -1;
     }
    
    my $e=$pos->{$time}+1;
    if (not defined $pos->{$time}){
	warn "ERROR variable ordenada no definida\n";
        exit -1;
    }
my $coma=',';
my $cad;
my $Z=scalar @$imprime;
for (my $oo=0; $oo<$Z; $oo++){
    if ($oo==$Z-1){
	$coma="";
    }
    my $iii;
    if (defined $pos->{$imprime->[$oo]}){
        $iii=$pos->{$imprime->[$oo]}+1;
    }else{
	warn "ERROR: no se calculo variable $imprime->[$oo]\n";
	exit -1;
        }
    $cad.=" '$archsal' using $e:$iii with lines title '$imprime->[$oo]'$coma ";
    }

   
   foreach (@$imprime){

   }
   
#my @ooo=('step',@$ordenfijo);
#my $Z=scalar @$ordenfijo;

#for (my $oo=0; $oo<$Z; $oo++){
#    if ($oo==$Z){
#	$coma="";
#        }
#    my $iii=$oo+2;
#    $cad.=" '$archsal' using $time:$iii with lines title '$ooo[$oo]'$coma ";
#    }


    #### HACER QUE EL MAXIMO DE LAS Y sea mayor al mayor numero, si es cte no se ve
    #print "$cad\n";
    #print "gnuplot -e \"plot $cad\" --persist \n";

    `gnuplot -e "plot $cad" --persist`;
}


# -----------------------------------------------------------------------------
sub leer_info_archivos{#toma informacion util del archivo; control minimo
    my($lista,$nombrearch)=@_;
    # llamada pór guardar_renglones

    Simusol::AyudasPP::comfin('com leer_info_archivos', @_);
    
  my @primeros = grep (do {$nombrearch->{$_} and not $selec{$_}},@$lista);
  my @posibles = (@primeros,@$lista); 
  @posibles = union_conjunto(@posibles);
  scalar keys %selec and contr_selec($nombrearch);# puede modificar %selec,%nombrearch 
  my $ignor = "se ignorará todo lo que se refiera a ";
  impr_debug(__LINE__.' sim3 @posibles',\@posibles);
#  $archivopadre->{SIMULADO} = 'SIMULADO';


  # POSIBLES SON LOS NOMBRES DE FANTASIA EN PARAPLOT
  #en $nombrearch para cada fantasia el que esta en el PARAPLOT


  #print Dumper \@posibles;
  # print Dumper \%refarch;
  #exit;
  foreach my $ARCHIVO (@posibles) {   
  

      #print "AAAAAAAAAAAAAAa $ARCHIVO\n";
      
      $refarch{$ARCHIVO} = {};
      my $refarchARCH =  $refarch{$ARCHIVO}; 
      my $ARCHIVOP ;
      $ARCHIVOP = $archivopadre->{$ARCHIVO};
      if (not defined $ARCHIVOP) {
          $ARCHIVOP = buscar_padre($ARCHIVO,$nombrearch);
      };	  
      if (not defined $exiarch{$ARCHIVOP}) {
	  calcular_exiarch($ARCHIVOP,$nombrearch);
      };
      $exiarch{$ARCHIVO} = $exiarch{$ARCHIVOP};	  
      my $nombrereal =   $nombrearch->{$ARCHIVO}->[0];
      if (defined $nombrereal) {
	  $nombarch{$ARCHIVO} = $nombrereal;
      };	  
       my (@inform, @listaval,@liscuantos);
      my ($ya,$repetidos,$seacabo) = ('','','');
      while (<ARCH>) {

	  #print "XXXXXXXXXXXXXXX $_ \n ";
          chomp;
          if (not $ya and s/\#\s*para\s+Simusol\W+//i) {
              $ya = 1;
              @inform = split /\s+/;

	      #print "QQQQQQQ @inform - $inform[0]\n";
              my @inform_un = union_conjunto (@inform);
              if (@inform == @inform_un) {
                  #los renglones siguientes deben tener la informacion
                  #shift @inform;
                  foreach my $que (@inform) {
                      my $renglon = <ARCH>;
		      #print "22XXXXXXXXXXXXXXX $que: $renglon \n ";
                      defined $renglon or do {
                          $seacabo = 1;
                          last; 
                      };
                      chomp $renglon;
                      $renglon =~ s/^\s*\#\s*//;
                      @{$refarchARCH->{$que}} = split /\s*,\s+/, $renglon;

		     
		      
		      
                      push @liscuantos,scalar @{$refarchARCH->{$que}}; # if $que ne 'variables';# por si tienen espacios  -

		     #print "MMMMMMM @liscuantos MMMMM $que MMMM ", Dumper $refarchARCH->{$que};
                       
                  };#my $que
                  $seacabo and do{
                      $refarchARCH = {};    
                  last;
                  } 
              } else {
                  $repetidos = 1; 
	      };# if else @inform ==
              next;
          };#if not $ya          
	  next if /\#/ or /^\s*$/; 
          s/^\s*(\S)/$1/;
          @listaval = split /\s+/; 
          $refarchARCH->{valores} = \@listaval; 
          push @liscuantos, scalar @listaval;
	  #print "MMMMMMM @liscuantos MMMMMMMMM  @listaval\n";
	  
          last;
      };#while


   
      if(not @listaval) {
          avgrav("no hay valores para $ARCHIVO de nombre real $nombrereal");
          $exiarch{$ARCHIVO} = 2; #sin valores numéricos
          next;
      };
      $refarchARCH->{colposibles} = @listaval;
      $ya or  $exiarch{$ARCHIVO} = 7; #arch. sin informacion
      $repetidos and 
           avnoseent("@inform; hay elementos repetidos para información
                 de $nombrereal");
      my @liscuan = union_conjunto(@liscuantos);    
      if (@liscuan == 1) {
          $exiarch{$ARCHIVO} = 10; # puede disminuir luego de otros controles 
      } else {
	  avnoseent("la información propia de $nombrereal;
            @liscuantos; debieran resultar iguales");
          $exiarch{$ARCHIVO} = 6; #inconsistencia en informacion
      };
      my $exiARCH = $exiarch{$ARCHIVO};
      my @genericasvar = (1..$refarchARCH->{colposibles});
      my @genericasunimag = @genericasvar;
      map ($_= '',@genericasunimag);
      map ($_ = 'col_'.$_, @genericasvar);

     
      ($exiARCH == 7 or not defined $refarchARCH->{sceptrevars}) and 
          @{$refarchARCH->{sceptrevars}} = @genericasvar; 
      ($exiARCH == 7 or not defined $refarchARCH->{variables}) and 
          @{$refarchARCH->{variables}} = @genericasvar; 
      ($exiARCH == 7 or not defined $refarchARCH->{magnitudes}) and 
          @{$refarchARCH->{magnitudes}} = @genericasunimag; 
      ($exiARCH == 7 or not defined $refarchARCH->{unidades}) and 
          @{$refarchARCH->{unidades}} = @genericasunimag;

# print "MMII $exiARCH ", Dumper $refarchARCH;
      
   #if (not defined $nombrereal
  };#for my $ARCHIVO
  
    $avisosgrav and  warn "Hubo errores en descripcion de archivos - $avisosgrav ";
    # se cambia die por warn!
    
  #Simusol::AyudasPP::parar3(210,"Hubo errores en descripcion de archivos");
  
  impr_debug(__LINE__.' sim3 %exiarch',\%exiarch); 
  @posibles = grep ($exiarch{$_} > 2, sort keys %exiarch);
  
  Simusol::AyudasPP::comfin('fin leer_info_archivos');
  return  \@posibles;
}#leer_info_archivos



# -----------------------------------------------------------------------------
sub buscar_padre{
    Simusol::AyudasPP::comfin('com buscar_padre',@_);

    
  my ($ARCHIVO,$nombrearch) = @_; 

  my $archp;
  my $nombrereal =   $nombrearch->{$ARCHIVO}->[0];
  if (not $selec{$ARCHIVO}) {
      if (defined $archivopadre->{$ARCHIVO}) {
	  $archp = $archivopadre->{$ARCHIVO};
      } else {
          $archp = $ARCHIVO; $archivopadre->{$ARCHIVO} = $archp;
      };
  } else {
      impr_debug(__LINE__.' sim3 $selec{$ARCHIVO}'
		 ,Dumper $selec{$ARCHIVO});
      my @lista = @{$selec{$ARCHIVO}->[0]};
      $archp = $lista[0];
      $archivopadre->{$ARCHIVO} = $archp;
  };
  Simusol::AyudasPP::comfin('fin buscar_padre',$archp);
  return $archp;
}#buscar_padre
#----------------------------------------------------------------------------
sub calcular_exiarch{
  Simusol::AyudasPP::comfin('com calcular_exiarch',@_);
  my ($ARCHIVO,$nombrearch) = @_;
  my $ignor = "se ignorará todo lo que se refiera a ";
  if (not defined $exiarch{$ARCHIVO} and not $selec{$ARCHIVO}) {
      if (not defined $nombrearch->{$ARCHIVO}) {
          $exiarch{$ARCHIVO} = 0; #falta nombre
          avgrav("No se indico nombre real para archivo $ARCHIVO; 
          $ignor $ARCHIVO");
      } else {
          @{$nombrearch->{$ARCHIVO}}
            = union_conjunto( @{$nombrearch->{$ARCHIVO}}); 
          if (@{$nombrearch->{$ARCHIVO}} >1) {
              $exiarch{$ARCHIVO} = 0; #más de un nombre
              avgrav("$ARCHIVO asociado con\n       ".
              join (' y ',  @{$nombrearch->{$ARCHIVO}}) . "
          $ignor $ARCHIVO");
          };  
	  my $nombrereal = $nombrearch->{$ARCHIVO}->[0];

	  #######################################   ??????????????????????? que pasa si hay varios
    	  
          if (not -e $nombrereal) {
	      my $DIRC=getcwd();
              $exiarch{$ARCHIVO} = 1;# no existe
              #avgrav(__LINE__." No existe el archivo $nombrereal dir: $DIRC LINEA 476 plotGNU;\n  $ignor $ARCHIVO");
	      warn " No existe el archivo $nombrereal dir: $DIRC LINEA 476 plotGNU;\n"
          } else {
              open ARCH, $nombrereal or do{
                  $exiarch{$ARCHIVO} = 1; #no abre
                  #avgrav("No se pudo abrir $nombrereal;\n  $ignor $ARCHIVO");
		  warn "No se pudo abrir $nombrereal;\n";
	      };# open
 	      $exiarch{$ARCHIVO} = 10;#puede disminuir en revision posterior
	      $nombarch{$ARCHIVO} = $nombrereal;
          };
      };
  };      
  Simusol::AyudasPP::comfin('fin calcular_exiarch');
  return    
}#calcular_exiarch   
# -----------------------------------------------------------------------------
sub completar_nombres{
    Simusol::AyudasPP::comfin('com completar_nombres',@_);

    my ($posi,$graff)=@_;    
   
   
    
  my @posibles = @{$posi};
  foreach my $ARCHIVO (@posibles) {
      my $nombrereal = $nombarch{$ARCHIVO};  

      my $refparapARCH = $refparap{$ARCHIVO};

     # print "ARCH $ARCHIVO ", Dumper $refparapARCH;



      ############# OJO si simplot ve que simul tiene mas variables que las pedidas en RESULTADOS EN CAJ protesta
      # esto esta bien en simusol, pero en otros contextos, podria haber mas variables en simul que las listadas en
      # RESULTADOS, si bien se complica con nombres diferentes
      # esto es complejo porque paraplot espera tener descripciones de todas las variables de simul
      # si hay menos results en el caj que en el simul da error aunque funciona
      # paraplot tiene que tener todas las variables del simul descriptas, aunque muestre menos
      # podria si estan sacar eso del simul
      # lo dejamos para el ds
      
      my $cuantos = $refparapARCH->{colposibles};
      if (not defined $refparap{$ARCHIVO}->{dni}){
	  $refparap{$ARCHIVO}->{dni}=[];
      }
      defined $refparapARCH->{ind} and $cuantos = @{$refparapARCH->{ind}};
      my $cuantossc = @{$refparap{$ARCHIVO}->{dni}};
      my @completado= 0;
      foreach my $que ('variables','magnitudes','unidades') {
          if (@{$refparapARCH->{$que}} == $cuantos) {
	  } else {
              if (@{$refparapARCH->{$que}} == 0) {
                  explic("No hay datos sobre $que en $ARCHIVO")  if $graff != 1;
                  $exiarch{$ARCHIVO} != 7 
                     and $exiarch{$ARCHIVO} = 4; #incompleta
              } else {
                  explic("$ARCHIVO con ".scalar @{$refparapARCH->{$que}}
                   . " $que, distinto de $cuantos") if $graff != 1; 
                  $exiarch{$ARCHIVO} = 7; #inconsistentes las cantidades
              };
              if ($que eq 'variables') {
                  map (do{push @{$refparapARCH->{variables}},'col_'.($_)}
                      ,@{$refparapARCH->{ind}});
              } else {
                  map (do{push @{$refparapARCH->{$que}}, ''}
                      ,@{$refparapARCH->{ind}});
              };
          }
      };
      if ($graff != 1) {
          if ($exiarch{$ARCHIVO} == 7) {
              avnograv
        ("Inconsistencia en cantidad de  variables, unidades y/o magnitudes
        para el archivo de nombre simbólico  $SIMBOARCHORI{$ARCHIVO}")
          } elsif ($exiarch{$ARCHIVO} == 3) {
              avnograv("No está completa la descripción del archivo
          de nombre simbólico $SIMBOARCHORI{$ARCHIVO} y real $nombrereal
          Los gráficos pueden resultar incorrectos") 
          }
      }; 
      @{$refparapARCH->{sceptrevars}} == $cuantossc or do{
          #solo se da si ind y dni son triviales   
          map (do{push @{$refparapARCH->{sceptrevars}},'col_'.($_)}
               ,@{$refparapARCH->{ind}});
      };
      @{$refvarori{$ARCHIVO}} = @{$refparap{$ARCHIVO}->{variables}};
      my $j = 1;
      foreach my $nombre (@{$refparap{$ARCHIVO}->{variables}}) {
          $nombre = sanear($nombre); #saca espacios y pone mayusc
	  $refnombreshashes->{$ARCHIVO}->{$nombre} = $j;
	  $refnombreshashes->{$ARCHIVO}->{$j} = $j;
          $j++; # si hay repetidos queda el ultimo
      };
  };
  Simusol::AyudasPP::comfin('fin completar_nombres');
}#contr_nombres
# ---------------------------------------------------------------------------
sub contr_archivos_paraplot{ #lo minimo para asegurar utilidad
    Simusol::AyudasPP::comfin('com contr_archivos_paraplot',@_);

    
    my ($la,$nombrearch,$archivosinext)=@_;
  my @listaARCH = @$la; 

  #todos tienen $exiarch 7 o 10; aqui pueden disminuir
  my $ign_info = 'se ignorará esta información';
  foreach my $ARCHIVO (@listaARCH) {
      my $refparapARCH;
      $refparapARCH = $refparap{$ARCHIVO};
       my $nombrereal = $nombrearch->{$ARCHIVO}->[0];
      if (not defined $refparapARCH) {
          $refparapARCH = $refparap{$ARCHIVO} = $refarch{$ARCHIVO};
          $refparapARCH->{ind} = [1..$refarch{$ARCHIVO}->{colposibles}];
          @{$refparapARCH->{dni}} = @{$refparapARCH->{ind}};
      } else {
          my $colpos;  
          foreach my $que ('sceptrevars','variables','unidades','magnitudes') {
              defined $refparapARCH->{$que} or $refparapARCH->{$que} = [];
              $colpos or $colpos = @{$refparapARCH->{$que}};
          };     
          if ($colpos) {
              if ($colpos > $refarch{$ARCHIVO}->{colposibles}) {
                  avgrav("Número de columnas de $nombrereal pretendidas en el 
                  archivo $archivosinext.paraplot mayor que el posible;
                  se ignorarán los pedidos referidos a este archivo");
                  $exiarch{$ARCHIVO} = 6;# descrip impos.  en paraplot    
                  $refparapARCH =  $refarch{$ARCHIVO};
                  next; 
              } else {
                  $refparapARCH->{colposibles} = $colpos;
              }
          } else {
              $refparapARCH->{colposibles} = $refarch{$ARCHIVO}->{colposibles};
              $refparapARCH->{ind} = [1..$refparapARCH->{colposibles}];
              $refparapARCH->{dni} = [1..$refparapARCH->{colposibles}];
          }; 
          if (@{$refparapARCH->{variables}} == 0) {$refparapARCH->{ind} = []}; 
          if (@{$refparapARCH->{variables}}) {
              if ($refparapARCH->{ind}) {
                  @{$refparapARCH->{ind}} == @{$refparapARCH->{variables}} or do{
		      my $s1= scalar @{$refparapARCH->{ind}};
		      my $s2= scalar @{$refparapARCH->{variables}};
		      #print "scalar ind  $s1 variables:  $s2 ind:  @{$refparapARCH->{ind}} \n variables:  @{$refparapARCH->{variables}}\n ";
                      avgrav("imposible la información de índices y variables para $nombrereal, ($ARCHIVO)");
                      $exiarch{$ARCHIVO} = 3;#imposible indices y variables

		      print Dumper $refparapARCH->{ind};
		      print Dumper $refparapARCH->{variables};
		      
                      next;
                  }; 
                  for(my $j = 0; $j < @{$refparapARCH->{ind}}; $j ++ ) {
                      my $k = $refparapARCH->{ind}->[$j];
                      next if $k == 0; 
                      $refparap{$ARCHIVO}->{dni}->[$k-1] = $j +1; 
                  }; 
                  @{$refparapARCH->{dni}} 
                   <= @{$refparapARCH->{sceptrevars}} or do{
                      avgrav(
                      "imposible la información de índices y sceptrevars para 
                       $nombrereal, ($ARCHIVO)");
                      $exiarch{$ARCHIVO} = 4;#indices y sceptrevars imposibles
                      next;
                  };
 	      } else {
      	          if (@{$refparapARCH->{sceptrevars}}>0 
                      and @{$refparapARCH->{sceptrevars}} 
	        	 < @{$refparapARCH->{variables}}) {
                      avgrav(
                      "imposible la información sobre sceptrevars, variables
                     e índices (no hay índices) para $nombrereal ($ARCHIVO)");
                      $exiarch{$ARCHIVO} = 5;# sceptrevar e ind. imposible
		      next;
                  };
              }; # if $refparapARCH->{ind} else ..
          };# if @{$refparapARCH->{variables}}  else ... == 0 
      }; # if not defined $refparapARCH else defined $refparapARCH
      unless ($refparapARCH->{ind} and @{$refparapARCH->{ind}}) {
          for(my $j = 0; $j < $refparapARCH->{colposibles}; $j ++ ) {
             $refparapARCH->{ind}->[$j] = $j+1;
             $refparapARCH->{dni}->[$j] = $j+1;
          }; 
      };
  }; # for my $ARCHIVO     
  # $avisosgrav and  Simusol::AyudasPP::parar3(230, '');

  # aparece en test21, sacado no se que hace  
  $avisosgrav and  warn $avisosgrav; # se cambia die por warn!

  
  my @posibles = grep ($exiarch{$_} > 5, sort keys %exiarch);
  Simusol::AyudasPP::comfin('fin contr_archivos_paraplot');
  return \@posibles;
}#contr_archivos_paraplot
#----------------------------------------------------------------------------
sub contr_selec{
    Simusol::AyudasPP::comfin('com contr_selec',@_);


    my ($nombrearch)=@_;

    
  my $ignor = "se ignorará todo lo que se refiera a ";
  foreach my $ARCHIVO (sort keys %selec) {
      impr_debug(__LINE__.' sim3 $ARCHIVO',$ARCHIVO);      
      impr_debug(__LINE__.' sim3 $SIMBOARCHORI{$ARCHIVO}'
        ,$SIMBOARCHORI{$ARCHIVO}); 
      impr_debug(__LINE__.' sim3 $nombrearch->{$ARCHIVO}'
		 ,$nombrearch->{$ARCHIVO});
      impr_debug(__LINE__.' sim3 $nombarch{$ARCHIVO}'
		 ,$nombarch{$ARCHIVO});
      impr_debug(__LINE__.' sim3',Dumper $selec{$ARCHIVO});
      my @listarefselecciones = union_conjunto(@{$selec{$ARCHIVO}});
      if (@listarefselecciones >1) {
          avgrav("Mas de una definicion para nombre real de $ARCHIVO;
                    $ignor $ARCHIVO");
          delete $selec{$ARCHIVO}; next;
      };
      my @listaseleccion = @{$listarefselecciones[0]};
      my $archp = $archivopadre->{$ARCHIVO} = uc($listaseleccion[0]);
      $exiarch{$ARCHIVO} = $exiarch{$archp};
      impr_debug(__LINE__.' sim3 $ARCHIVO,@listaseleccion,$archp'
        ,[$ARCHIVO,@listaseleccion,$archp]);
  };    
  Simusol::AyudasPP::comfin('fin contr_selec');
  return      
}#contr_selec      
# -----------------------------------------------------------------------------
sub contr_sobre_archivos{
    Simusol::AyudasPP::comfin('com contr_sobre_archivos',@_);

   
    my ($refparposibles,$nombrearch,$archivosinext,$archivos,$elemento)=@_;
    
#  impr_debug(__LINE__.' sim3 %nombarch', Dumper \%nombarch);
  my @archposibles = @$refparposibles;
  my @SIMULADOs = grep(/^SIMULADO/,@archposibles);
  if (@SIMULADOs) {
      @SIMULADOs = union_conjunto(sort @SIMULADOs);
      $SIMULADOs[0] eq 'SIMULADO' or do{
          #no hubo archivo ni arch_var para SIMULADO, pero se usan SIMULADO_...
          unshift @SIMULADOs,'SIMULADO';
          push @{$nombrearch->{SIMULADO}}, "$archivosinext.simul";
          $SIMBOARCHORI{SIMULADO} = 'SIMULADO';
      };      
  };
  @archposibles = grep ($exiarch{$_} >5, sort keys %exiarch);
  impr_debug(__LINE__.' sim3 @archposibles',\@archposibles);
  impr_debug(__LINE__.' sim3 %refparap',Dumper \%refparap);  
  foreach my $ARCHIVO (@archposibles) {
      next if $selec{$ARCHIVO};
      my $nombrereal =   $nombarch{$ARCHIVO};
      my $refparapARCH = $refparap{$ARCHIVO};
      if (not defined $refparapARCH->{variaciones}) {
	  $refparapARCH->{variaciones} = [''];


	  
	  
          $marca{$nombrereal} = '';
      } elsif (@{$refparapARCH->{variaciones}} >1) {
	  
          # Simusol::AyudasPP::parar3(30,"En $archivosinext.paraplot Hay más de una definición de
           #     variaciones $ARCHIVO");
           warn "En $archivosinext.paraplot Hay más de una definición de   variaciones $ARCHIVO";
	   
      } elsif (@{$refparapARCH->{variaciones}} == 0) {
      } elsif ($refparapARCH->{variaciones} eq '') {  #### agregado por dsa
      } else { #queda     == 1
	  #print Dumper  $refparapARCH;


	  #print Dumper $refparapARCH->{variaciones};
	  $marca{$nombrereal} = $refparapARCH->{variaciones}->[0];
          $refparapARCH->{variaciones} = $refparapARCH->{variaciones}->[0];	  
	  
	  
      };
      if (not defined $refparapARCH->{arch_var}) {
	  $refparapARCH->{arch_var} = [$nombrereal];
      } elsif (@{$refparapARCH->{arch_var}} >1) { 
#          Simusol::AyudasPP::parar3(32,"En $archivosinext.paraplot Hay más de una definición de 
	  #                arch_var $ARCHIVO");
	   warn "En $archivosinext.paraplot Hay más de una definición de arch_var $ARCHIVO";  
      } elsif (@{$refparapARCH->{arch_var}} == 0) {
	  $refparapARCH->{arch_var} = [];
      } else {# queda   == 1
	  $refparapARCH->{arch_var} = $refparapARCH->{arch_var}->[0];
      };
      if (@{$refparapARCH->{arch_var}} 
          and @{$refparapARCH->{variaciones}} == 0) {
  #         Simusol::AyudasPP::parar3(33,"En $archivosinext.paraplot hay un renglón
 #            arch_var $ARCHIVO pero no hay un renglón
#             variaciones $ARCHIVO");
	    warn "En $archivosinext.paraplot hay un renglón
             arch_var $ARCHIVO pero no hay un renglón
             variaciones $ARCHIVO";
      };
      if (@{$refparapARCH->{arch_var}} and @{$refparapARCH->{variaciones}} and
	  @{$refparapARCH->{arch_var}} != @{$refparapARCH->{variaciones}}) {
          avnoseent("En $archivosinext.paraplot 
                variaciones $ARCHIVO   y arch_var $ARCHIVO
            tienen distinta cantidad de elementos");
          $refparapARCH->{arch_var} = []; 
          $refparapARCH->{variaciones} = [];   
      };
  }; #$ARCHIVO
  impr_debug(__LINE__.' sim3 %nombarch', Dumper \%nombarch);
  contr_arch_variables(@archposibles);
  contr_variac(\@archposibles,$nombrearch,$archivosinext);
  contr_selec($nombrearch);
  impr_debug(__LINE__.' sim3 %exiarch',\%exiarch);
  foreach my $ARCHIVO (sort keys %selec) {
      impr_debug(__LINE__.' sim3 $exiarch{$ARCHIVO}',$exiarch{$ARCHIVO});
      next if defined $exiarch{$ARCHIVO} and $exiarch{$ARCHIVO} < 6;
      seleccionar_filas($ARCHIVO,\@{$selec{$ARCHIVO}->[0]},$archivos,$elemento);
  };
  Simusol::AyudasPP::comfin('fin contr_sobre_archivos');
}#contr_sobre_archivos
# -----------------------------------------------------------------------------
sub contr_variac{
  Simusol::AyudasPP::comfin('com contr_variac', @_);

   my ($archivosX, $nombrearch,$archivosinext)=@_;
  my @ARCHIVOS = @$archivosX;
  # aqui no uso $archivo_padre; copio los datos
  foreach my $key (@ARCHIVOS) {
      next if $selec{$key};
      my $refparapkey = $refparap{$key};
      my $nombre = $nombarch{$key};
      my @marcas = @{$refparapkey->{variaciones}};
      if (@{$refparapkey->{arch_var}}== 0) {  
          my ($propio,$ext) = ($nombre =~ /^(\w+)(\.\w+)$/);
          if (defined $propio and defined $ext) {
              @{$refparapkey->{arch_var}} = ("$propio$ext");
              for (my $i = 1; $i < @marcas; $i++) {
                  my $nombrei = $propio . "_$i". $ext;
                 (-f $nombrei and -s $nombrei) or
                 #  Simusol::AyudasPP::parar3(36,"En $archivosinext.paraplot hay un renglón
                 # variaciones $key pero no hay un renglón
                 # arch_var $key; y no pude crearlo");

                  warn "En $archivosinext.paraplot hay un renglón
                  variaciones $key pero no hay un renglón
                  arch_var $key; y no pude crearlo";
		  
                  push  @{$refparapkey->{arch_var}}, $nombrei;
             };
          }; 
      };
      my @listaarch = @{$refparapkey->{arch_var}};
      my $nombremaster = $nombrearch->{$key}->[0];
      my ($propio,$ext) = $nombremaster =~ /^(.+)(\.\w+)$/;
      my $noarchvar; 
      $marca{$nombremaster} = $marcas[0];
      for( my $i= 1; $i < @listaarch; $i ++) {
	  my $ARCHi = "${key}_$i";
          my $nombrei = $listaarch[$i];

	  #print "NOMBREI $nombrei\n";
	  
          if (not defined $nombrei or not $nombrei or  not -f $nombrei or not -s $nombrei) {
             $noarchvar = 1;
          } else {
             $nombarch{$ARCHi} =  $nombrei;
             $exiarch{$ARCHi} = $exiarch{$key};
             my @lista = @{$refvarori{$key}};
             $refvarori{$ARCHi} = [@lista]; 
             @{$refparap{$ARCHi}->{variables}} 
                 = @{$refparap{$key}->{variables}};
             @{$refparap{$ARCHi}->{magnitudes}} 
                 = @{$refparap{$key}->{magnitudes}};
             $refparap{$ARCHi}->{unidades} = $refparap{$key}->{unidades};
	     $refparap{$ARCHi}->{sceptrevars} = $refparap{$key}->{sceptrevars};
             $marca{$nombrei} = $marcas[$i];  
             $unipri{$ARCHi} = $unipri{$key};
             $refparap{$ARCHi}->{arch_var} = [];
             $refnombreshashes->{$ARCHi} = $refnombreshashes->{$key};
	 };
	 if ($noarchvar) {
             avnograv("No se pueden atender arch_var; 
              no existen todos los archivos"); 
             $refparapkey->{arch_var} = [];$refparapkey->{variaciones} = [];
         };
      }; 
  };
  Simusol::AyudasPP::comfin('fin contr_variac');
} #contr_variac
# -----------------------------------------------------------------------------
sub contr_arch_variables{
  Simusol::AyudasPP::comfin('com contr_arch_variables');
   my @listaARCH = @_;
  foreach my $ARCHIVO (@listaARCH) {
      if ($refparap{$ARCHIVO}->{sceptrevars} 
           and $refparap{$ARCHIVO}->{variables}) {
          for (my $j = 0; $j < @{$refparap{$ARCHIVO}->{sceptrevars}}; $j++) {
              my $sceptre = $refparap{$ARCHIVO}->{sceptrevars}->[$j];
              my $i = $refparap{$ARCHIVO}->{dni}->[$j];
	      #test16 da error con $i
              defined $i or $i = 0;  
              my $propio = $refparap{$ARCHIVO}->{variables}->[$i-1];
              not defined $refnombreshashes->{$ARCHIVO}->{$sceptre} and
                 $refnombreshashes->{$ARCHIVO}->{$sceptre} = $i;          
	  };
      };
  }; # for $ARCHIVO
  Simusol::AyudasPP::comfin('fin contr_arch_variables');
  return;
} # contr_arch_variables
# -----------------------------------------------------------------------------
sub contr_graf{          
    # crea guardar_graf en guardar_renglones, o le suma en graficar_interact
    # controla uso previo  e inicializa si hace falta

    my ($arra,$guardar_graf,$archivos,$elemento,$plf,$pun_lin)=@_;

    Simusol::AyudasPP::comfin('com contr_graf',@_);
    

    my $BASEARCH=$archivos->{arg}->{$elemento}->{dirs}->[1];
    # ERA $PROPIOASIN
    my $propiosin=$archivos->{arg}->{$elemento}->{dirs}->[0];

    foreach my $grafo (@$arra) {
      my $grafoori= $grafo;
      my $grafo = lc($grafoori);
      if (not defined $exigraf{$grafo}){
          $exigraf{$grafo} = 0; $simbografori{$grafo} = $grafoori;
          $titx{$grafo} = $tity{$grafo} = $plf->{$grafo} = $mj{$grafo} = '';
          $rx{$grafo} = $ry{$grafo} = ''; 
          $fun{$grafo} = []; $pun_lin->{$grafo} =[];

	  #################################################   aqui se carga  guardar_graf
	  # reemplazar por resolve_dir
          my $archi=File::Spec->catfile($BASEARCH, $propiosin . "_$grafo".".gnu");
	  # lo de abajo no fuinciona porque despues, en funcion de lo que aqui pasa se carga 
	  #print "K", Dumper $archivos->{arg}->{$elemento};	  
	  #print "XXXXXXXXXXXXXXXXXXXXZ $archivos->{arg}->{$elemento}->{$grafo}->{gnu}\n";
          $archi=~s/\.gnu//;
	  my $filearchi = file($archi);
	  $filearchi->cleanup;  # saca el punto
	 
          $guardar_graf->{$grafo} = "$filearchi";  # ojo las comillas son importantes pq hacen string el objeto
          $uniabscisa{$grafo} = ''; $uniordenadas{$grafo} = '';
          $usagraf_coma_arch_cols{$grafo} = [];
      };
    };


    return($guardar_graf);
  Simusol::AyudasPP::comfin('fin contr_graf');
}# contr_graf
# -----------------------------------------------------------------------------
sub contr_graf_arch_cols{
  my ($graf,$arch,$listacol,$graff) = @_; 
    
  Simusol::AyudasPP::comfin('com3 contr_graf_arch_col',@_);
  #se ocupa de una pareja graf,arch en lo que tiene que ver preparando para 
  #titulos y conversion de unidades 

  my $archp = $archivopadre->{$arch}; #imprescindible si hubo seleccion
  defined $archp  or $archp = $arch;
  my $haycol = $refarch{$archp}->{colposibles};
  if ($graff > 1 and defined $refparap{$archp}->{variables}) {
      $haycol = @{$refparap{$archp}->{variables}}
  };
  impr_debug(__LINE__.' sim3 $haycol',$haycol);
  #impr_debug(__LINE__.' sim3 $refnombreshashes',Dumper $refnombreshashes);
  my @cols = split /[\:\,]+/, $listacol;
  map(s/\s//,@cols);
  my @malascols;
  impr_debug(__LINE__.' sim3 @cols',\@cols);
  foreach (@cols) {
      next if /^\d+$/ and $_ <= $haycol;
      my $colori = $_;
      $_ ne '0' and $_ = $refnombreshashes->{$archp}->{sanear($_)};
      impr_debug(__LINE__.' sim3 $_', $_);
      defined $_ or do{push @malascols, $colori; $_ = -1};
  }; 
  if (@malascols > 0) {
     avnoseent("el pedido del grafico \"$graf\" con variables
       ".join (' ', @malascols )
       ." para archivo de nombre simbolico $arch");
     return \@cols,\@malascols;	  
  };
  my @buenascols = grep (do{$_ <= $haycol and $_ >=  0}, @cols); 
  my @colsord = sort {$a <=>$b} (union_conjunto(@cols));
  my $ncol = $colsord[-1];
  my $unidad = $unipri{$archp};
  if (not defined $unidad) {
      $unidad = $refparap{$archp}->{unidades}->[0];
  };
  if (defined $unidad and defined  $datosPlotGNU->{unist}->{lc($unidad)} ){
          $unidad = $datosPlotGNU->{unist}->{lc($unidad)};
  };
  defined $unidad or $unidad = ''; 
  Simusol::AyudasPP::comfin('fin3 contr_graf_arch_col', [$graf,$arch,'||',@cols,'||',@malascols]);
  return [@cols], [@malascols];
}#contr_graf_arch_col
####################################################

# -----------------------------------------------------------------------------
sub contr_jun{ #NO SE USA?
#    my %juntos;
    map($juntos{$_}++ ,@mostrarjunto);
    if (scalar keys %juntos < scalar @mostrarjunto) {
       avnograv(
     "Hay más de un pedido de mostrarjunto  para un(os) archivos(s)
	 Solo se atenderá al último. Revisar: "
	 . join (' ', 
	     map($simbografori{$_},grep($juntos{$_}>1, sort keys %juntos))));     
    }  
}#contr_jun
# -----------------------------------------------------------------------------
sub contr_titulos_ejesxy{
  Simusol::AyudasPP::comfin('com contr_titulos_ejesxy',@_);
  my $grafo = $_[0];
  if ($titx{$grafo}) {
      if ($titx{$grafo} =~ /\((\w+)\)/) {$uniabscisa{$grafo} = $1};
      if ($tity{$grafo} =~ /\((\w+)\)/) {$uniordenadas{$grafo} = $1};
      return;
  };
  my @r =   #@r es lista de referencias a ... @cosas
    ($magord{$grafo}, $uniord{$grafo}, $varabsc{$grafo}, $uniabsc{$grafo}
     ,$prig{$grafo},$segg{$grafo});
  my @resul; my @cosas = ('magnitud de ordenada','unidad de ordenada'
                          ,'variable para abscisa', 'unidad para abscisa'
                          ,'prig', 'segg');
  unshift @{$uniabsc{$grafo}}, @{$prig{$grafo}};
  unshift @{$uniord{$grafo}}, @{$segg{$grafo}};
  foreach my $reff (@r) {
      my @listita = union_conjunto(@$reff); 
      my @listitasel = grep(do{defined $_ and $_ ne '??'},@listita);
      my $nombre = shift @cosas;
      @listitasel or do{push@resul, '';next};
      my $sele = '';
      defined $listitasel[0] and $sele = $listitasel[0]; 
      if ($nombre =~ /^uni/) {
          #$sele = " ($listitasel[0])";
          my @initiempo = grep($datosPlotGNU->{unist}->{$_},@listitasel);
          @initiempo == @listitasel and do{
              @listitasel = ($sele); 
          };
      };
      @listitasel = grep(/\S/,@listitasel);
      @listitasel = union_conjunto(@listitasel); 
      @listitasel >1 and  do{
	  my @mayusculas = @listitasel; 

          map(do{$_ = uc($_);$_ =~ s/\s+//g},@mayusculas);
          @mayusculas = union_conjunto(@mayusculas);
          @mayusculas >1 and avnograv("Posibles nombres para  $nombre: 
          @listitasel           se elige $sele");          
      };
      push @resul, $sele;
  };
  $uniabscisa{$grafo} = $resul[3];$uniordenadas{$grafo} = $resul[1];
  $titx{$grafo} = $resul[2]; $resul[3] and $titx{$grafo} .= " ($resul[3])";
  $tity{$grafo} = $resul[0]; $resul[1] and $tity{$grafo} .= " ($resul[1])";
  Simusol::AyudasPP::comfin('fin contr_titulos_ejesxy');
}#contr_titulos_ejesxy
# -----------------------------------------------------------------------------
sub extraer{
   my $texto = $_[0];my @listita = ();
   if ($texto =~ /(.*)\(\s*(\S.*)\s*\)/) {
       my $unidad = $2; my $var = $1; $var =~ s/^\s*//;$var =~ s/\s*$//;
       $unidad = $datosPlotGNU->{unist}->{lc($unidad)}
         if defined $datosPlotGNU->{unist}->{lc($unidad)};# %unist, solo para tiempo
       return $var,$unidad;
   } else {
       return '??','??';
   }    
}#extraer
# -----------------------------------------------------------------------------
sub graficar_pedidos{
    my ($archivos,$elemento,$exigraf,$mensajegra,$nomostrar,$lisarchsimul,$reruns,$guardar_graf,$archivo,$dirarchivo,$plf,$pun_lin,$nombrearch,$noverb,$graff,$mensaje_comienzo,$nograffile)=@_;

    my $losgnu={};
    
    Simusol::AyudasPP::comfin('com3 graficar_pedidos',@_);

    #   print Dumper $guardar_graf,$exigraf;
    #    exit;

    my $archivosingra=$archivo;
    $archivosingra=~s/\.gra$//;
    $archivos->{arg}->{$elemento}->{gra}->{archivosingra}= $archivosingra;
    
    #print Dumper $exigraf;
    #exit;
    
    foreach my $grafo (sort sort keys %$exigraf) {

       grarch($archivos,$elemento,$dirarchivo,$grafo,$guardar_graf->{$grafo});
      
       }
    
    # print Dumper $archivos;
    #   exit;

    #    exit;
    #print Dumper $archivos->{arg}->{$elemento};
    #exit;
    
    #  print Dumper $guardar_graf;
    #  print Dumper $nombrearch;
    #  exit;

    #print Dumper $pun_lin;
	
    my $noarchresori={};     
    foreach my $grafo (sort keys %$exigraf) {
      next if defined $juntos{$grafo};

      llenar_desde_arch($grafo,'',$nombrearch,$graff);
      impr_grafo($grafo,'graficar_pedidos',$guardar_graf,$plf);
      
      contr_titulos_ejesxy($grafo);
      
      pun_lin($grafo,\%usagraf_coma_arch_cols, $archivopadre,\%uniabscisa,\%uniordenadas,\%nombarch,\%refparap,$pun_lin,\%refvarori,\%marca,\%selec);            
      my $funfun = funciones($grafo);      
      $plf->{$grafo} = join (",\\\n", @{$pun_lin->{$grafo}}, @{$funfun});

      #      print "plotgnu 1098 ", Dumper $plf;     
      #  exit;
            
      #print "GRAFEARAA $grafo\n";
      next if $juntos{$grafo};
      #print "GRAFEARAA2 $grafo\n";
      my ($lgnu)=grafear('G',$grafo,$guardar_graf,$archivos,$elemento,$plf,$graff,$mensaje_comienzo);                              # CREAGNU
      #print "LGNU ", Dumper $lgnu;
      foreach(@$lgnu){	  
	  $losgnu->{$_->[1]}=$_->[0];
          }
      if (not defined $nomostrar{$grafo}) {
        #          my $impre =  
        #" Archivos asociados con  \"$simbografori{$grafo}\": $guardar_graf->{$grafo}.gnu\n ";
        #        $impre .=  ' ' x 10 . "$guardar_graf->{$grafo}.eps   $guardar_graf{$grafo}.png";
        #        explic($impre);
        };
      };
    #mostrar_juntos
    my ($lgnu)=grafear('M',$noarchresori,$guardar_graf,$archivos,$elemento,$plf,$graff,$mensaje_comienzo) if scalar keys %juntos;             # CREAGNU
    foreach(@$lgnu){	  
	  $losgnu->{$_->[1]}=$_->[0];
          }
    #print Dumper "PUN_LIN ", $pun_lin;  
    my @mensno = grep($exigraf->{$_} == 0,sort keys %$exigraf);
    @mensno = map($_ = $simbografori{$_}, @mensno);
    @mensno and avnograv("Nada para poner en los graficos 
        " . join (', ', sort @mensno));
    my @lisnomostrar = grep($exigraf->{$_},sort keys %nomostrar);
    my @lisexigraf = grep($exigraf->{$_},sort keys %$exigraf);
    explic('=' x 70);

    my $archi;  
    if (@lisnomostrar) {
      $archi = $lisnomostrar[0];
    }else{
      $archi = $lisexigraf[0];
      };

    defined $archi or   warn 'No quedo nada para graficar';
    #Simusol::AyudasPP::parar3(208,'No quedo nada para graficar');

    #impr_todo(__LINE__.' sim3',$ref3);  # PROVISORIO ?
    #  my ($ba, $pr,$co) = relativizar("$ref3->{BASEARCH}$guardar_graf->{$archi}",
    #				  $ref3->{curdirori});
    #  OJO ESTO ERA LO NUEVO, copie aqaui lo viejo para que ande!!!  
    #  my ($ba, $pr,$co) = relativizar("$BASEARCHA$guardar_graf->{$archi}",$pwdori);
    explic(
   " --- Los archivos como el $elemento.gnu pueden editarse;
       y con        gnuplot -persist $elemento.gnu\n"
             . "     muestran el grafico y producen:\n" . ' ' x 20 
       .  "$elemento.eps   $elemento.png"); 
    my $errorgnuplot = '';


    my @ppplll=map { $exigraf->{$_}?$_: () } sort keys %$exigraf;

#      next unless $exigraf->{$grafo};
    
    my ($archivogra,$Xarchivosgra,$paraarchivos,$paraver)=dibu(\@ppplll,$mensajegra,$nomostrar,$archivos,$elemento,$guardar_graf,$noarchresori,$nograffile);

    return   ($archivogra,$Xarchivosgra,$paraarchivos,$paraver,$losgnu);
    # movido a leer paraplot    
    #  my $renglon = `grep "arch_var SIMULADO" $propiosin.paraplot`;
    #  chomp $renglon; 
    #  $renglon =~ s/^arch_var SIMULADO = $propiosin.simul\,//; 
    #  my @lisarchsimul = split ',', $renglon;
    # NO HACE NADA CON LISARCHSIMUL
    #### rerun _1.simul _2.simul
        
    Simusol::AyudasPP::comfin('fin3 graficar_pedidos');
}#graficar_pedidos                  

#############################################################################
  sub ejecutar_graf{
	my($archivogra,$Xarchivosgra,$archivos,$elemento)=@_;
	    
	 #print "XXXXXXXXXXXXXXXX $archivogra \n ";
	 my $a=file($archivogra);
         if (not $a->is_absolute) {
           $archivogra=File::Spec->catfile("./",$archivogra);  # para que se pueda ejecutar debe tener un dir adelante
	   }	 
         
              
	my ($stdout, $stderr, $errorcod);
	
        ($stdout, $stderr, $errorcod)=capture {          
         my $pid;
         $pid = fork();
         if (not defined $pid) {
             warn "Recursos indisponibles para fork.\n";
         }elsif ($pid == 0) {
          #print "Proceso hijo para graficar\n";
          #system "firefox http://localhost:$port";
          system($archivogra);  # hacer fork!!!
          exit(0);
          }
        };     
	 
	print $stdout;
        #warn $stderr;   # da warnings no se que sonxs
	
	#### hacere subrutina grabar file
      Simusol::AyudasPP::archiva("${Xarchivosgra}_gnuplot.ls1",'F',$archivos,$elemento); 
      open my $GRALS1, ">", "${Xarchivosgra}_gnuplot.ls1";
      print $GRALS1  $stderr;
      close $GRALS1;
      my @ls1 = split("\n",$stderr);
      
      #my $errorcod = system "$earchivogra 2>${Xarchivosgra}_gnuplot.ls1";
      #system "grep -vi Warning.*empty ${Xarchivosgra}_gnuplot.ls1";
      #my @ls1 = `cat ${Xarchivosgra}_gnuplot.ls1`;
      @ls1 = grep(do {$_ !~ /Warning.*empty/},@ls1);
      
      map(mensajear(" $_"), @ls1);

      explic ("Cierre graficos con \"q\"; o click en la \"x\"; o ......
             se cerraran solos la proxima vez que simusol produzca graficos");
      $errorcod and do{
          avgrav("Ha habido problemas al preparar los graficos");
	  
	 # Simusol::AyudasPP::parar3(50,'');
	  warn "Ha habido problemas al preparar los graficos con $archivogra";
      };
 
    #print "\n";

}
###############################################################
   sub grarch{
	my ($archivos,$elemento,$dirarchivo,$ggrafo,$GGG)=@_;
  my $basen=file($GGG)->basename;
  my ($archivoeps,$camino1,$x2)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.eps',$basen);
  Simusol::AyudasPP::archiva($archivoeps,'F',$archivos,$elemento);
  Simusol::AyudasPP::creacamino($camino1,$archivos,$elemento,0);
      my ($archivopng,$camino2,$x4)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.png',$basen);
       Simusol::AyudasPP::archiva($archivopng,'F',$archivos,$elemento);
       Simusol::AyudasPP::creacamino($camino2,$archivos,$elemento,0);
       
       my ($archi,$camino6,$x5)     =Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.gnu',$basen);
       Simusol::AyudasPP::creacamino($camino6,$archivos,$elemento,0);
       Simusol::AyudasPP::archiva($archi,'F',$archivos,$elemento);
       
       my ($archivodumb,$camino7,$x7)     =Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.dumb',$basen);
       Simusol::AyudasPP::creacamino($camino7,$archivos,$elemento,0);
       Simusol::AyudasPP::archiva($archivodumb,'F',$archivos,$elemento);
       
       $archivos->{arg}->{$elemento}->{$ggrafo}->{gnu}=$archi;
       # las relativas son a la ubicacion del gra, las no relativas son a BASEARCH, donde se ejecuta este programa
       $archivos->{arg}->{$elemento}->{$ggrafo}->{relgnu}= Simusol::AyudasPP::relativa($archi,$dirarchivo);
       $archivos->{arg}->{$elemento}->{$ggrafo}->{releps}= Simusol::AyudasPP::relativa($archivoeps,$dirarchivo); 
       $archivos->{arg}->{$elemento}->{$ggrafo}->{relpng}= Simusol::AyudasPP::relativa($archivopng,$dirarchivo);
       $archivos->{arg}->{$elemento}->{$ggrafo}->{reldumb}= Simusol::AyudasPP::relativa($archivodumb,$dirarchivo);


    }
 

# -----------------------------------------------------------------------------
sub graficar_interact{

    my ($guardar_graf,$archivos,$elemento,$plf,$pun_lin,$nombrearch,$noverb,$graff,$mensaje_comienzo,$nograffile,$dirarchivo)=@_;


    
    my $losgnu={};
    my $arc=$archivos->{arg}->{$elemento}->{dirs};
    my $PROPIOSIN  =$arc->[0];
#    my $PROPIOASIN= Simusol::AyudasPP::simpl_archivo($PROPIOSIN);  
    
  Simusol::AyudasPP::comfin('com graficar_interact',@_);
  my $i=0; my @lisposibles;
    print  '-' x 70,"\n Archivos disponibles para graficar:\n";
    my $ilish={};
  foreach my $simbarch (sort keys %SIMBOARCHORI) { 
#q      next if $exiarch{$simbarch} < 2;#CUIDADO
      #(defined $refparap{$simbarch}->{variables} 
      #  and @{$refparap{$simbarch}->{variables}} >1) or next;
      $i++;
      printf " %3d:   %1s =   %1s\n",$i,  $simbarch, $nombarch{$simbarch}; 
      push @lisposibles, $simbarch;
      $ilish->{$i}=$simbarch;
  }; #foreach 
  my $simbarch = '';   
  if (@lisposibles == 0) {
      #Simusol::AyudasPP::parar3(200,'Ningún archivo se puede graficar');
      warn 'Ningún archivo se puede graficar';
  } elsif ($noverb) {
      #Simusol::AyudasPP::parar3(201,'La opcion "-noverb" impide graficar interativamente');
      warn 'La opcion "-noverb" impide graficar interativamente';  
  } elsif (@lisposibles > 1) {
      ### print Dumper \@lisposibles;
      print "Seleccione un subconjunto de ellos, indicando sus numeros, separados por comas (enter para salir):";
      my $ilistita = <STDIN>; 
      chomp $ilistita;
      $ilistita=~s/^\s+//;
      $ilistita=~s/\s+$//;
      my @ld=split(/\s*,\s*/,$ilistita);
      my @nld=();
      foreach(@ld){
	  if (exists $ilish->{$_}){
	      push (@nld, $ilish->{$_});
	  }else{
              warn "la opción seleccionada ($_) no corresponde a un archivo elegible\n";
	  }
      }
      my $cant=scalar @nld;
      print "LISTA ELEGIDA (cant $cant): @nld\n";
      @lisposibles=@nld;
      
#      my ($juntos,$refhashnumarch, $lispos) = Simusol::AuxiliaresPP::seleccionar_archivo('','',\@lisposibles);     
#      #print "LIS @lisposibles - @$lispos ", Dumper $refhashnumarch;
#      my @lpos;
#      foreach (@$lispos){
#        push (@lpos,  $lisposibles[$refhashnumarch->{$_}]);
#      }
#      @lisposibles=@lpos;
#      #print "LIS @lisposibles \n";
      print "   Si quiere un gráfico, 
      indíquelo a continuación\n";
  };       
  print "   Si quiere un gráfico con los datos de algunos  de ellos, 
      indíquelo a continuación\n";
  my $ya = '';

    my $jj=1;

  #  print "LISPOS @lisposibles\n";
  my $haygrafo = '';
  my @punlin = (); 
  my @pl;
  my @parajuntos;
  my $tot = scalar @lisposibles;
    
  for (my $j =0; $j < $tot; $j ++) {
        $ya = 1;
        $haygrafo = '';
	
	print "=====================================\n ARCHIVO de donde elegir: $lisposibles[$j], ",$j+1," de ",$tot," \n";
        while ($ya eq 1){	  
         my $ggrafo = $PROPIOSIN."_interact_$jj";  
         contr_graf([$ggrafo],$guardar_graf,$archivos,$elemento,$plf,$pun_lin);
         $guardar_graf->{$ggrafo} = $PROPIOSIN."_interact_$jj";
         grarch($archivos,$elemento,$dirarchivo,$ggrafo,$guardar_graf->{$ggrafo});
         
	 
         ($ya)= pedir_graf($losgnu,$lisposibles[$j],$ggrafo,$PROPIOSIN,$guardar_graf,$archivos,$elemento,$plf,$pun_lin,\%nombarch,$graff,$mensaje_comienzo);
	 # ya es 0 o 1, o sea no tiene sentido el if /elsif
         #if ($ya =~ /1/) {
         if ($ya) {
              $haygrafo = 1;
 	      $jj++;
	      #print "KKKKKKKKKK $ggrafo \n ";
	      #print Dumper $losgnu;

	      # ejecutar con losgnu y     ejecutar_graf_sa{
	      # no hacer eps png dumb     revisar todas esas funciones
	      print "GNU $archivos->{arg}->{$elemento}->{$ggrafo}->{gnu}\n";
	      
              my $coderr = system "gnuplot -persist $archivos->{arg}->{$elemento}->{$ggrafo}->{gnu}";

	      
              explic("$ggrafo.gnu, $ggrafo.eps, $ggrafo.png 
                son los archivos correspondientes al gráfico;
                serán sobreescritos la próxima vez .....");
	      }
	  #}elsif ($ya =~ /2/){
	  #    #print "XXXXXXXXXXXXXXXX\n";
          #    my ($lgnu)=grafear('G',$ggrafo,$guardar_graf,$archivos,$elemento,$plf,$graff,$mensaje_comienzo);
	  #    foreach(@$lgnu){	  
         # 	  $losgnu->{$_->[1]}=$_->[0];
         #         }
         #
         #     $ya = 1;    
	 # };
	   }; #while

        } # for

    my $noarchresori={};
    my $juntagraf=1;
    $jj--;
    my $haygrafahora=$jj;

    ###########################################################################################
    print Dumper $plf;
    print Dumper $losgnu;
    
    while($juntagraf and $haygrafahora>1){ # solo si hay 2 o mas, en ese caso haygrafahora es 3       
          print 'x'x 20," Quiere colocar varios de los gráficos anteriores, uno sobre otro, en una ventana (s|y|n), hay $haygrafahora gráficos? ";
          my $resp = <STDIN>;
          chomp $resp;
	  if (not $resp =~ /[sy]/i) {
	      $juntagraf=0;
	      last;
	      }
          #print "LISPOSIBLES @lisposibles\n";
          my @fw=sort keys %$losgnu;
          @parajuntos=();
	  foreach (@fw){
	    if ($_=~/_acu_/) {              
              next;
	      };

	    $_=~s/\.gnu$//;
	    my $REMP=$Simusol::AyudasPP::dirsalida->{'.gnu'};
	    $_=~s/^$REMP\///;
	    #print "MMMMMM $REMP - $_   \n";
            if (@fw >1) {  # OJO ES > no >=
            #        if (@lisposibles >= 1 and $haygrafo) {  # OJO ES > no >=
            print 'x'x 20," Quiere juntar ese gráfico: $_ con otros (s|y|n)? ";
            my $resp = <STDIN>;
            chomp $resp;
            if ($resp =~ /[sy]/i) {
              push @pl, $plf->{$_};
	      $exigraf{$plf->{$_}}= $plf->{$_};
	      push (@parajuntos,$_);
              };
	    };
	   }# foreach fin
           #exit;
    
           #foreach(@pl){
           #}
           my $tt=1;
           if (@pl) {
              my $gacugrafo=$PROPIOSIN."_interact_acu_$tt";
              $gacugrafo = $guardar_graf->{$gacugrafo} = $PROPIOSIN."_interact_acu_$tt";
              grarch($archivos,$elemento,$dirarchivo,$gacugrafo,$guardar_graf->{$gacugrafo});
              #print Dumper $archivos;
      
              $plf->{$gacugrafo} = join ", \\\n",@pl;#para tener generalidades del ultimo
              #print "XXXXXXXXXXXXXXXX 2 $ggrafo\n";

              # print "todo ", Dumper \%todo;       
              #### USA %juntos y %exigraf    %todo  !!!!
              $juntos{$gacugrafo}=[@parajuntos];
              #print "juntos ", Dumper \%juntos;
              my ($lgnu)=grafear('M',$noarchresori,$guardar_graf,$archivos,$elemento,$plf,$graff,$mensaje_comienzo);           
              foreach(@$lgnu){	  
          	  $losgnu->{$_->[1]}=$_->[0];
                  }
      
             #print "XXXXXXXXXXXXXXXXX ", Dumper $losgnu;
             #exit;
      
             my $coderr = system "gnuplot -persist $archivos->{arg}->{$elemento}->{$gacugrafo}->{gnu}"; 
             explic("$gacugrafo.gnu, $gacugrafo.eps, $gacugrafo.png   
              son los archivos correspondientes al gráfico;
              seran sobrescritos al crear otro grafico con ese nombre.");
      
            }; # if

          }#while
###########################################################################################################################
    #my $noarchresori={};
    $juntagraf=1;
    @pl=();
    while($juntagraf and $haygrafahora>1){ # solo si hay 2 o mas, en ese caso haygrafahora es 3       
          print 'x'x 20," Quiere producir un gráfico que junte las series de otros (s|y|n), hay $haygrafahora gráficos? ";
          my $resp = <STDIN>;
          chomp $resp;
	  if (not $resp =~ /[sy]/i) {
	      $juntagraf=0;
	      last;
	      }
          #print "LISPOSIBLES @lisposibles\n";
          my @fw=sort keys %$losgnu;
          #@parajuntos=();
	  foreach (@fw){
	    if ($_=~/_acu_/ or $_=~/_acuuno_/) {              
              next;
              }; 
	    $_=~s/\.gnu$//;
            my $REMP=$Simusol::AyudasPP::dirsalida->{'.gnu'};
	    $_=~s/^$REMP\///;
            if (@fw >1) {  # OJO ES > no >=
            #        if (@lisposibles >= 1 and $haygrafo) {  # OJO ES > no >=
            print 'x'x 20," Quiere juntar ese gráfico: $_ con otros (s|y|n)? ";
            my $resp = <STDIN>;
            chomp $resp;
            if ($resp =~ /[sy]/i) {
              push @pl, $plf->{$_};
	      #$exigraf{$plf->{$_}}= $plf->{$_};
	      #push (@parajuntos,$_);
              };
	    };
	   }# foreach fin
           #exit;
    
           #foreach(@pl){
           #}
           my $tt=1;
           if (@pl) {
              my $gacugrafo=$PROPIOSIN."_interact_acuuno_$tt";
              $gacugrafo = $guardar_graf->{$gacugrafo} = $PROPIOSIN."_interact_acuuno_$tt";
              grarch($archivos,$elemento,$dirarchivo,$gacugrafo,$guardar_graf->{$gacugrafo});
              #print Dumper $archivos;
      
              $plf->{$gacugrafo} = join ", \\\n",@pl;#para tener generalidades del ultimo
              #print "XXXXXXXXXXXXXXXX 2 $ggrafo\n";

              # print "todo ", Dumper \%todo;       
              #### USA %juntos y %exigraf    %todo  !!!!
              #$juntos{$ggrafo}=[@parajuntos];
              #print "juntos ", Dumper \%juntos;
              my ($lgnu)=grafear('G',$gacugrafo,$guardar_graf,$archivos,$elemento,$plf,$graff,$mensaje_comienzo);           
              foreach(@$lgnu){	  
          	  $losgnu->{$_->[1]}=$_->[0];
                  }
      
             #print "XXXXXXXXXXXXXXXXX ", Dumper $losgnu;
             #exit;
      
             my $coderr = system "gnuplot -persist $archivos->{arg}->{$elemento}->{$gacugrafo}->{gnu}"; 
             explic("$gacugrafo.gnu, $gacugrafo.eps, $gacugrafo.png   
              son los archivos correspondientes al gráfico;
              seran sobrescritos al crear otro grafico con ese nombre.");
      
            }; # if

          }#while
    
 



    #################################################################################################################
    explic("   no quiso nada más");
    #print Dumper \@pl;
    #print Dumper $guardar_graf;
    #print Dumper $losgnu;

    my @w=sort keys %$losgnu;
    my @ww=();
    foreach (@w){
	$_=~s/\.gnu$//;
	#print "$_\n";
	push (@ww,$_);
        }
    
    my ($archivogra,$Xarchivosgra,$paraarchivos,$paraver)=dibu([@ww],{},{},$archivos,$elemento,$guardar_graf,$noarchresori,undef);

    
    # print "GRA $archivogra , ,$Xarchivosgra,$paraarchivos,$paraver ", Dumper $losgnu;   
    # exit;
   
    return ($archivogra,$Xarchivosgra,$paraarchivos,$paraver,$losgnu,$guardar_graf);
    Simusol::AyudasPP::comfin('fin graficar_interact');  
    #   Simusol::AyudasPP::parar3(206,'');
    warn 'Nose, fin graficar interact';
} #graficar_interact
# -----------------------------------------------------------------------------
sub pedir_graf{
  my ($losgnu,$simbarch,$grafo,$PROPIOSIN,$guardar_graf,$archivos,$elemento,$plf,$pun_lin,$nombarch,$graff,$mensaje_comienzo) = @_;


  #print "SIM $simbarch ", Dumper \%refvarori;

  
  Simusol::AyudasPP::comfin('com pedir_graf',@_);
  my (@connumeros,@lisunis);
  print '-' x 20," $nombarch->{$simbarch} ", '-' x10, "\n";
  if ($simbarch eq 'SIMULADO') {
      my @res = `cat $PROPIOSIN.res`;
      @connumeros = grep (/^..\d/g, @res);
      print join('',@res);
  } else {
      @connumeros = @{$refvarori{$simbarch}};
      @lisunis = @{$refparap{$simbarch}->{unidades}};
      for (my $i = 0; $i < @connumeros; $i++) {
          my $uni = $lisunis[$i];  $uni and $uni ="($uni)";
          printf "%5i: %10s %3s\n", $i+1, $connumeros[$i],$uni;  
      };   
  };
  my $refbuenas;
  my $cuantos = @connumeros;
  my ($absc,@lista);my $biennum = 9;
       my $mensnovalido = "\n" .'X' x 20 
   . " indicación no válida; pida por ejemplo     1, 2\n";
  until ($biennum eq 1) {
       print " Si quiere poner en un gráfico algo de este archivo,
             indique números o nombres de variables  que interesan 
             separados por \",\"   o   \":\" 
               para abscisa y ordenadas:
           (0 para abscisas, si quiere lista de valores;
           simplemente ENTER, si no quiere nada más de este archivo;
            o Control-C para terminar con todo)  "; 
      $absc = <STDIN>;chomp $absc;
      if ($absc =~ /^\s*$/) { # or $absc =~ /^\s*0\s*$/) {
	  return 0;
      };
      if (not $absc =~ s/^\s*([\'\"\s\,\;\:\w]+)\s*$/$1/) {
 	  mensajear($mensnovalido. __LINE__);
          next;
     };
      my ($haycomillas,$cambio,$error) = ('',1,''); 
       print "loliloli $absc\n";
      while ($absc =~ /[\'\"]/ and $cambio and not $error) {
	      print "loliloli entre0\n";
	  $haycomillas = 1;
	  $cambio = '';
          while ($absc =~ /^[^\'\"]*\'([\w\s]+)\'/) {
	      print "loliloli entre1\n";
              my $sust = $refnombreshashes->{$simbarch}->{sanear($1)};
              defined $sust or
	      do {avnoseent(" a que variable se refiere  \'$1\'");
                  $error = 1; last;
              };
              $absc =~ s/^([^\'\"]*)\'([\w\s]+)\'/$1$sust/;
              $cambio = 1;
          };
          while ($absc =~ /^[^\'\"]*\"([\w\s]+)\"/) {
	      print "loliloli entre2\n";
              my $sust = $refnombreshashes->{$simbarch}->{sanear($1)};
              defined $sust or
	      do {avnoseent(" a que variable se refiere  \"$1\"");
                  $error = 1; last;
              };
              $absc =~ s/^([^\'\"]*)\"([\w\s]+)\"/$1$sust/;
              $cambio = 1;
          }; 
      };
      $haycomillas and not $cambio and
      do {
	  mensajear( "$absc ". $mensnovalido.__LINE__);
          next;
       };
      $absc =~ s/\s/,/g; 
      ($refbuenas,my $refmalas) 
           = contr_graf_arch_cols($grafo, $simbarch, $absc,$graff);
      
      #@lista =  split(/[\s\,\;\:]+/,$absc);$biennum = 9;
      if (@$refmalas) { 
          mensajear(" $absc ". $mensnovalido);
          next
      } elsif (@$refbuenas == 1) { 
          print 
       "       faltan los números de variables para ordenadas: "; 
          my $orden = <STDIN>;
          chomp $orden;
	  $absc .= ",$orden";
          ($refbuenas,$refmalas) 
              = contr_graf_arch_cols($grafo, $simbarch, $absc,$graff);
          @$refbuenas and not @$refmalas and $biennum = 1;
      };
      $biennum = 1 if $biennum; 
  };# until
      $usagraf_coma_arch_cols{$grafo} = [['g_linea', $simbarch, $refbuenas ]];
  my @buenas = @$refbuenas;
  llenar_desde_arch($grafo,'',$nombarch,$graff);
  $titx{$grafo} = $tity{$grafo} = $plf->{$grafo} = $mj{$grafo} = '';
  $uniabscisa{$grafo} = ''; $uniordenadas{$grafo} = '';
  contr_titulos_ejesxy($grafo);
  $pun_lin = {};
#  pun_lin($grafo);
   pun_lin($grafo,\%usagraf_coma_arch_cols, $archivopadre,\%uniabscisa,\%uniordenadas,$nombarch,\%refparap,$pun_lin,\%refvarori,\%marca,\%selec);

  $plf->{$grafo} = join(",\\\n",@{$pun_lin->{$grafo}});
  my ($lgnu)=grafear('G',$grafo,$guardar_graf,$archivos,$elemento,$plf,$graff,$mensaje_comienzo) if $plf->{$grafo};
  foreach(@$lgnu){	  
          	  $losgnu->{$_->[1]}=$_->[0];
                  }
  Simusol::AyudasPP::comfin('fin pedir_graf');
  return (1);   
  } #pedir_graf
# -----------------------------------------------------------------------------
sub llenar_desde_arch{  
  my ($grafo,$modo,$nombrearch,$graff) = @_; #$modo falso desde vacios.
  Simusol::AyudasPP::comfin('com llenar_desde_arch',@_);

    my @puntoslineas = @{$usagraf_coma_arch_cols{$grafo}};
    unless  ($modo) {
      $varabsc{$grafo} = [];
      $uniabsc{$grafo} = [];
      $magord{$grafo} = [];
      $uniord{$grafo} = [];
      $prig{$grafo} = [];$segg{$grafo} = []
  };
  foreach my $refrenglon (@puntoslineas) {my $simbarchp;
      my ($comando,$simbarch,$reflista) = @{$refrenglon};
      impr_debug(__LINE__.' sim3 $simbarch',$simbarch);
      if ($archivopadre->{$simbarch}) {
	  $simbarchp = $archivopadre->{$simbarch};
      } else {
          $simbarchp = buscar_padre($simbarch,$nombrearch);
      };	  
      next unless @$reflista;   
      my @buenas = @$reflista;
      my $absc = shift @buenas; 
      if ($absc  ne 0) { 
          push @{$varabsc{$grafo}}, $refvarori{$simbarchp}->[$absc-1]; 
          push @{$uniabsc{$grafo}}
              , $refparap{$simbarchp}->{unidades}->[$absc-1];
      } else {
          push @{$varabsc{$grafo}}, 'numero de orden en el archivo';
          push @{$uniabsc{$grafo}}, '';
          unshift @{$prig{$grafo}}, 'numero de orden en el archivo';
      };
      if ($graff ne 1 and $absc == 1 and defined $unipri{$simbarch}) {
          if ($simbarchp eq 'SIMULADO') {
              unshift @{$prig{$grafo}}, $unipri{$simbarchp};
          } else {
              push @{$prig{$grafo}}, $unipri{$simbarchp}; 
          };
      };
      if (join (' ',(' ',@buenas)) =~ / 1 / and defined $unipri{$simbarchp}) {
          if ($simbarchp eq 'SIMULADO') {
              unshift @{$segg{$grafo}}, $unipri{$simbarchp};
          } else {
              push @{$segg{$grafo}}, $unipri{$simbarchp}; 
          };
      };        
      map (do{push @{$magord{$grafo}}
              , $refparap{$simbarch}->{magnitudes}->[$_ -1]},@buenas);
      map  (do{push @{$uniord{$grafo}}
                      , $refparap{$simbarch}->{unidades}->[$_ -1]},@buenas);
  };
  my ($pg,$sg) = ($uniabsc{$grafo}->[0],$uniord{$grafo}->[0]);
    @{$prig{$grafo}} and $pg = $prig{$grafo}->[0];
  @{$segg{$grafo}} and $sg = $segg{$grafo}->[0];
  Simusol::AyudasPP::comfin('fin llenar_desde_arch');
}#llenar_desde_arch  
# -----------------------------------------------------------------------------

######################################################
 sub pantallas{
  my ($nucleo,$tiposgraf,$dumbarch,$archivog)=@_;
  # dumbarch solo se activa si en tiposgra hay dumb 
  # tiposgra: ['dumb','dumbarch','X11','png','eps']  
  my $pusonucleo=0;
  my $archgnu='';
  my $comms=0;
  
  # nota lo ideal seria sacar comentarios por cuerda aparte y solo ponerlos en los archivos no en la ejecucion, pero
  # es mas complejo por que se mezclan
  # los filtramos

  foreach my $tipograf (@$tiposgraf){
  
    if ($tipograf eq "X11"){ 
      $archgnu.="set term X11\n";     
    }elsif($tipograf eq 'dumb'){    
      if (not $comms){
       $archgnu.="#  (   Para ver buen grafico en pantalla, cambie\n";
       $archgnu.="#     set term dumb    por   set term X11     )\n";
       $archgnu.="#     o vea unas líneas mas adelante \n";
       $comms=1;
      }
      $archgnu.="set term dumb\n";
    }elsif($tipograf eq 'dumbarch'){
      if (not $comms){
       $archgnu.="#  (   Para ver buen grafico en pantalla, cambie\n";
       $archgnu.="#     set term dumb    por   set term X11     )\n";
       $archgnu.="#     o vea unas líneas mas adelante \n";
       $comms=1;
      }
      $archgnu.="set term dumb\n";
      $archgnu.="set output '$archivog->{$tipograf}'\n"  ;
    }else{        
          $archgnu.="set term $datosPlotGNU->{term}->{$tipograf}\nset output '$archivog->{$tipograf}'\n";     
          }
    if ($pusonucleo){
          $archgnu.="replot\n"
      }else{
          $archgnu.=$nucleo;
	  $pusonucleo=1;
          }  

      }


return ($archgnu);

    
#  foreach  my $tipograf  ('eps','png') {
#      print $ESTE "set term $datosPlotGNU->{term}->{$tipograf}\nset output '$archivog->{$tipograf}'\nreplot\n";
#      $archgnu.="set term $datosPlotGNU->{term}->{$tipograf}\nset output '$archivog->{$tipograf}'\nreplot\n";
#  };
}



######################################################
 sub pantallasjuntas{
  my ($textografo,$multiplot,$tiposgraf,$archivog,$size)=@_;
  # dumbarch solo se activa si en tiposgra hay dumb 
  # tiposgra: ['dumb','dumbarch','X11','png','eps']  
  #my $pusonucleo=0;
  my $archgnu='';
  #my $comms=0;
  
  # nota lo ideal seria sacar comentarios por cuerda aparte y solo ponerlos en los archivos no en la ejecucion, pero
  # es mas complejo por que se mezclan
  # los filtramos

  foreach my $tipograf (@$tiposgraf){
  
      if ($tipograf eq "X11"){
	     $archgnu.="set term X11\nset size $size,$size\nset origin 0.0 ,0.0\n";      
             $archgnu.="set multiplot\nset lmargin 11\nset bmargin 1\n";

    }elsif($tipograf eq 'dumb'){    
 #     if (not $comms){
 #      $archgnu.="#  (   Para ver buen grafico en pantalla, cambie\n";
 #      $archgnu.="#     set term dumb    por   set term X11     )\n";
 #      $archgnu.="#     o vea unas líneas mas adelante \n";
 #      $comms=1;
 #     }
 #     $archgnu.="set term dumb\n";
    }elsif($tipograf eq 'dumbarch'){
 #     if (not $comms){
 #      $archgnu.="#  (   Para ver buen grafico en pantalla, cambie\n";
 #      $archgnu.="#     set term dumb    por   set term X11     )\n";
 #      $archgnu.="#     o vea unas líneas mas adelante \n";
 #      $comms=1;
 #     }
 #     $archgnu.="set term dumb\n";
 #     $archgnu.="set output '$archivog->{$tipograf}'\n"  ;
    }else{

           $archgnu.="set term $datosPlotGNU->{term}->{$tipograf}\nset output \'$archivog->{$tipograf}\'\n";        


          }
             $archgnu.=$multiplot.$textografo."set nomultiplot\nreset\n";
      }


return ($archgnu);

    
#  foreach  my $tipograf  ('eps','png') {
#      print $ESTE "set term $datosPlotGNU->{term}->{$tipograf}\nset output '$archivog->{$tipograf}'\nreplot\n";
#      $archgnu.="set term $datosPlotGNU->{term}->{$tipograf}\nset output '$archivog->{$tipograf}'\nreplot\n";
#  };
}


############################################################################
sub grafear{                                            ########### CREAGNU

    my ($grafomostrar,$grafo,$guardar_graf,$archivos,$elemento,$plf,$graff,$mensaje_comienzo) = @_;

    my $archgnu;
    my $archi; 

    my $archivog;

    $archivog->{X11}='';
    
    
    if ($grafomostrar eq 'G'){

    ########################## GRAFEAR
	
    #my ($noarchresori,$guardar_graf,$archivos,$elemento,$graff,$mensaje_comienzo)=@_;                                       # CREA GNU

    Simusol::AyudasPP::comfin('com grafear',@_);

    my $panta0 = # "set term X11\n". # no hace falta
      #"set locale 'es_ES'\n".
      "set grid\n";
    ########################################## poner como configuracion
        
    if ($juntos{$grafo}) {
      Simusol::AyudasPP::comfin('fin grafear linea',__LINE__);
      #return;
      };

   # print Dumper $archivos;
   # exit;
    
    $archi=$archivos->{arg}->{$elemento}->{$grafo}->{gnu};
    $archivog->{eps}=$archivos->{arg}->{$elemento}->{$grafo}->{releps};
    $archivog->{png}=$archivos->{arg}->{$elemento}->{$grafo}->{relpng};
    $archivog->{dumbarch}=$archivos->{arg}->{$elemento}->{$grafo}->{reldumb};


    # print Dumper $plf;
    # exit;
    
    if ($plf->{$grafo}) {
      $exigraf{$grafo} = 1;
    }else{
      warn "GRAFICO $grafo VACIO!!";
      Simusol::AyudasPP::comfin('fin grafear linea',__LINE__);
      #return;
  }


  # print Dumper $archivos->{arg}->{$elemento}->{gra}->{nombresimul};
  #  exit;
    
  my ($panta1,$impre1) = ('','');
  $panta1 = $impre1 = "set title '$titulograf{$grafo}'\n"
    if defined $titulograf{$grafo} && $titulograf{$grafo} ne '';
  $panta1 .= "set xlabel '$titx{$grafo}'\n" 
    if defined $titx{$grafo} && $titx{$grafo} ne '';
  my $titlejey = '';
  defined $tity{$grafo} and $titlejey = $tity{$grafo}; 
  #Hay que poner titulo al eje y aunque sea vacio porqe de otro modo
  #para grafos multiples el segundo puede copiar titulo del primero

  $panta1 .="set ylabel '$titlejey'\n";


  # el contenido del gnu no es relativo al gnu, sino al gra, que es quien ejecuta el gnu

    
    # PARA CREAR EL GNU    
    ############################
    #sigue lo copiado de dibu

    #my ($archivoeps,$x1,$x2)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.eps',$guardar_graf->{$grafo});
    #my ($archivopng,$x3,$x4)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.png',$guardar_graf->{$grafo});
    #my ($archi,$x6,$x5)     =Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.gnu',$guardar_graf->{$grafo});
    #my $archi=relativa ($guardar_graf->{$grafo},$archivos->{arg}->{$elemento}->{gra}->{dirarchivo});
   
 
	
    #print "GRAFO $grafo $archivoeps REL $archi, $guardar_graf->{$grafo}, X $archivos->{arg}->{$elemento}->{gra}->{dirarchivo} \n"; 
    #exit;
  #################################################################

  

    #$archi=~s/^XXXBASEXXX//;
    # NO ES GRAFO!!!!

    #print Dumper $archivos->{arg}->{$elemento}->{gra}->{nombresimul};
    #exit;
    

    my @sim=sort keys %{$archivos->{arg}->{$elemento}->{gra}->{nombresimul}};

    foreach(@sim){
     my $cn=scalar @{$archivos->{arg}->{$elemento}->{gra}->{nombresimul}->{$_}->[1]};
     foreach my $num (0..$cn-1){
	my $no=$archivos->{arg}->{$elemento}->{gra}->{nombresimul}->{$_}->[1]->[$num];
	my $ni=$archivos->{arg}->{$elemento}->{gra}->{nombresimul}->{$_}->[0]->[$num];
        #print "NNNN $num $no - $ni - $_\n";
	if ($no ne $ni){
	    my $U=$plf->{$grafo};
            #print "NNNNXX $plf->{$grafo}\n";
            $plf->{$grafo}=~s/'$no'/'$ni'/g;
	     my $UU=$plf->{$grafo};
            #print "NNNNYY $plf->{$grafo}\n";

	    if ($U ne $UU){
#                   print "CAMBIOOOOOOOOOOOOOOOOOOOOOOOO\n"
	    }
	}
    }
    }
  

 # my ($simul)=split(/ using/, $plf{$grafo});
 # $simul=~s/^'//;
 # $simul=~s/'$//;
 #print "ARCHI $archi $simul\n";
 #my $nuevosimul=relativa ($simul,$archivos->{arg}->{$elemento}->{gra}->{dirarchivo});

  
 # print "NUEVO SIMUL $nuevosimul:   $plf{$grafo}\n";

    
##  print "ARCHI $simul -- $plf{$grafo} - $grafo\n";
#  # my $archifile = file($archi);
#  # my $archibase= $archifile->basename;
#  # my $archidir = $archifile->parent;    
##  my $simulfile = file($simul);
##  my $simuldir = $simulfile->parent;
##  my $simulbase= $simulfile->basename;
##  my $simulrel = $simuldir->relative($archivos->{arg}->{$elemento}->{gra}->{dirarchivo});
##  my $nuevosimul= file($simulrel,$simulbase);


    
    
#  my $archibase= file($archi)->basename;
#  my $archipngeps=$archibase;
#  $archipngeps=~s/\.gnu$//;


 #   print "EPS PN  $archipngeps \n";
#exit;

  
    my $rangos='';
    if (defined $rx{$grafo} and defined $rx{$grafo} ){
  if ( $rx{$grafo}  eq '' and $ry{$grafo} ne '') {
      $rangos = "[] $ry{$grafo}";
  } else {
      $rangos = $rx{$grafo}.$ry{$grafo}; 
  };
    }
    
  #  $archi.='.gnu';

  Simusol::AyudasPP::archiva($archi,'F',$archivos,$elemento);   
  open my $ESTE,">$archi" or die "No puedo crear $archi (1)\n";
  
  $todo{$grafo} = $panta0. $panta1. "plot $rangos\\\n$plf->{$grafo} \n"; 
  my $size = 1; $size = 0.7 if $graff eq '5';
  print $ESTE "\# GRAFEAR archivo $guardar_graf->{$grafo} $mensaje_comienzo ";
  print $ESTE "$guardar_graf->{$grafo}\n";
    #     print $ESTE "cd XXXXXX\n";                             no hay forma de calcular el cambio de directorio necesario desde el gra si se mueve el gnu

  my $nucleo="set size $size,$size\nset origin 0.0 ,0.0\n";
  $nucleo.=$todo{$grafo};

   my $tiposgraf=['dumb','dumbarch','X11','png','eps'];
    
   if (defined $nomostrar{$grafo}){ 
       $tiposgraf=['dumb','dumbarch','png','eps'];
       }
   
   # aqui se la usa primero 
   ($archgnu)= pantallas($nucleo,$tiposgraf,1,$archivog);
    
   print $ESTE $archgnu;

   #print  "NU $nucleo, @$tiposgraf, ARCHGNU: ", $archgnu, "\n";
    
 
   close $ESTE;
   #exit -1;
  Simusol::AyudasPP::comfin('fin grafear linea',__LINE__);
  return ([[$archgnu,$archi]]);


    
#######################################################	
    }else{
	my $lgnu;
	$lgnu=[];
	#print "########################## MOSTRAR_JUNTOS $grafo\n";

   my	$noarchresori=$grafo;
    # no se usa $plf pero para igualar con grafear
  Simusol::AyudasPP::comfin('com mostrar_juntos',@_);
  my $size = 1; $size = 0.7 if $graff eq '5';
  foreach my $grafj (sort keys %juntos) {
      defined $guardar_graf->{$grafj} or
      do {$guardar_graf->{$grafj} = $grafj;
          $noarchresori->{$grafj} = 1;
  };

      #print "MMMMMMMMMMM  $grafj\n";
      $archi=$archivos->{arg}->{$elemento}->{$grafj}->{gnu}; 
      $archivog->{eps}=$archivos->{arg}->{$elemento}->{$grafj}->{releps};
      $archivog->{png}=$archivos->{arg}->{$elemento}->{$grafj}->{relpng};
      $archivog->{dumb}=$archivos->{arg}->{$elemento}->{$grafj}->{reldumb};

    #print "GRAFO $grafo $archivoeps REL $archi, $guardar_graf->{$grafo}, X $archivos->{arg}->{$elemento}->{gra}->{dirarchivo} \n"; 

    #my ($archivoeps,,$x1,$x2)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.eps',$guardar_graf->{$grafj});
    #my ($archivopng,$x3,$x4)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.eps',$guardar_graf->{$grafj});
    #my ($archi,$x6,$x5)     =Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.gnu',$guardar_graf->{$grafj});
      
    #my $archik=relativa ($guardar_graf->{$grafj},$archivos->{arg}->{$elemento}->{gra}->{dirarchivo});
    #print "GRAFO $grafj $archivoeps REL $archik - $guardar_graf->{$grafj}\n";
  #################################################################
      
   #   my $archi=$guardar_graf->{$grafj};
      #   $archi.='.gnu';
      Simusol::AyudasPP::archiva($archi,'F',$archivos,$elemento); 
      open my $ESTE,">$archi" 
          or die "No puedo crear $guardar_graf->{$grafj} (2)\n";
      my @graf = @{$juntos{$grafj}};
      @graf = grep($exigraf{$_},@graf);
      if (@graf == 0) {
          $exigraf{$grafj} = 0;
          next;
      }; 
      print $ESTE "\# MOSTRAR_JUNTOS archivo $archi $mensaje_comienzo $archi\n ";

      my $multiplot = "set multiplot\nset lmargin 11\nset bmargin 1\n";
      my $cuantos = scalar @graf;
      my $altura = $size*0.90/$cuantos; 
      my $textografo = '';
      #print "GRAF $cuantos,  @graf \n";
      for (my $i = 0; $i < $cuantos; $i ++) { #solo se espera $cuantos  2 
          my $grafo = $graf[$i];
          next if not defined $todo{$grafo};
          my $texto = "$todo{$grafo}";
          my @lista = split(/\n/,$texto); 
          my $yorigen = $size - ($i+1) * $altura;
          $textografo .= "set size $size,$altura\nset origin 0.0 ,$yorigen\n";
          foreach(@lista) {
	      next if /set xlabel/ and $i != $cuantos-1;
	      next if /set term/ ;
              last if /term postcript/;
              $textografo .= "$_\n"; 
          };
      };
      
      ### archgnu comienza
 my $tiposgraf=['X11','png','eps'];
 ($archgnu)= pantallasjuntas($textografo,$multiplot,$tiposgraf,$archivog,$size);

 #     print "ARCH $archgnu - $textografo - $multiplot \n";
#	  $archgnu='';
      #print $ESTE "set term X11\nset size $size,$size\nset origin 0.0 ,0.0\n";
#      $archgnu.="set term X11\nset size $size,$size\nset origin 0.0 ,0.0\n";      
#      $archgnu.="set multiplot\nset lmargin 11\nset bmargin 1\n";
      #print $ESTE "$multiplot";
#      $archgnu.="$multiplot";

      #print $ESTE $textografo;
#      $archgnu.=$textografo;
      #print $ESTE "set nomultiplot\n"."reset\n";
#      $archgnu.="set nomultiplot\n"."reset\n";
#      foreach my $tipograf ('eps','png') {
          #print $ESTE "set term $datosPlotGNU->{term}->{$tipograf}\nset output \'$archivog->{$tipograf}\'\n";
#	   $archgnu.="set term $datosPlotGNU->{term}->{$tipograf}\nset output \'$archivog->{$tipograf}\'\n";
          #print $ESTE $multiplot, $textografo, "set nomultiplot \n reset\n";
#	   $archgnu.= $multiplot.$textografo."set nomultiplot \n reset\n";
#           };
      
 #     print "ARCH $archgnu\n";
#	  exit -1;

      print $ESTE $archgnu;
      close($ESTE);


				
#      my $impre =  
#   " Archivos asociados con  \"$simbografori{$grafj}\": $guardar_graf->{$grafj} ";
#      $impre .= "\n" . ' ' x 10 . 
#        "$guardar_graf->{$grafj}.eps   $guardar_graf->{$grafj}.png";
#      explic($impre);
      $exigraf{$grafj} = 1;

      push (@$lgnu,[$archgnu,$archi]);
      
  };
  Simusol::AyudasPP::comfin('fin mostrar_juntos');


    return ($lgnu);
    }
    

   
} 
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
sub dibu{  #crea y llena el archivo .gra con lo necesario 
  my ($lllppp,$mensajegra,$nomostrar,$archivos,$elemento,$guardar_graf,$noarchresori,$nograffile) = @_;


  #print Dumper $guardar_graf;

  #exit;
  
  Simusol::AyudasPP::comfin('com dibu',@_);
  
  #my ($archivo,$dirarchivo,$x3)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.gra','');

   my $archivo=$archivos->{arg}->{$elemento}->{gra}->{archivo};
   my $dirarchivo=$archivos->{arg}->{$elemento}->{gra}->{dirarchivo};
   my $archivosingra=$archivos->{arg}->{$elemento}->{gra}->{archivosingra};
  
  #my $archivosingra=$archivo;
  #$archivosingra=~s/\.gra$//;

 # esto esta mal por el clas 
 # my $archivosingra=$archivos->{arg}->{$elemento}->[2];
 # my $dirarchivo=$archivos->{arg}->{$elemento}->[1];
  
  #print Dumper $archivos;
  #exit;

  #print "ARCH $archivo, ELE $elemento \n";
  #exit;
  #$archivo=File::Spec->catfile($BASEARCH,$archivo.".gra");
  my $DIBUJAR;
  my $hacearch=0;
  my $paraarchivos='';
  my $paraver='';
  if (not defined $nograffile and not $nograffile){
      $hacearch=1;
    Simusol::AyudasPP::archiva($archivo,'F',$archivos,$elemento);   
    my $ok=open $DIBUJAR,">$archivo"; 
    if (not $ok) {
      warn "No se puede escribir $archivo";
      return;
      };
    #Simusol::AyudasPP::parar3(210,"No se puede escribir $archivo");
    # ojo verificar bin/bash!!!
    # https://stackoverflow.com/questions/59895/getting-the-source-directory-of-a-bash-script-from-within
     
    my $agrego=<<'END_MESSAGE';
SOURCE="${BASH_SOURCE[0]}"
while [ -h "$SOURCE" ]; do # resolve $SOURCE until the file is no longer a symlink
  DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
  SOURCE="$(readlink "$SOURCE")"
  [[ $SOURCE != /* ]] && SOURCE="$DIR/$SOURCE" # if $SOURCE was a relative symlink, we need to resolve it relative to the path where the symlink file was located
done
DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
echo DIR $DIR
cd $DIR
END_MESSAGE
  
  
    if (-e '/bin/bash'){
      print $DIBUJAR "#!/bin/bash\n";      
    }else{
      warn "No encuentro /bin/bash\n";
      exit -1;
      }
    print $DIBUJAR "$agrego\n";
    }

  foreach my $grafo (@$lllppp) {
      my $mens = '';

      #my $archi = $guardar_graf->{$grafo};

      #my $file = file($archi);
      #my $filedir = $file->parent;
      #my $filebase= $file->basename;
      #my $rel = $filedir->relative($dirarchivo);
      #$archi= file($rel,$filebase);

      #$archi=$filebase;
#      print "GRAFO $grafo ", Dumper $archivos->{arg}->{$elemento};

      
      my $archi=$archivos->{arg}->{$elemento}->{$grafo}->{relgnu};
      # print "REL $archi - $rel - $filebase\n";
      #exit;
      # movido de contr  
      #  my $archi = $guardar_graf{$grafo};

      # NO PUEDE NO ESTAR DEFINIDO, porque no fue creado el GNU
      if (not defined $archi) {
	  warn "NO DEFINIDO $grafo\n";
	  exit -1;
	  
          my $propiosin=$archivos->{arg}->{$elemento}->{dirs}->[0];
          #$guardar_graf->{$grafo} = $PROPIOASIN . "_$grafo";
	  $guardar_graf->{$grafo} = $propiosin . "_$grafo";
          $noarchresori->{$grafo} = 1;
	  $archi = $guardar_graf->{$grafo};
	  ######################################### sirve guardar en guarar_graf? o directamente archi? 
          
          };

      #$archi.='.gnu';
      # USAR resolver_dir
      #my $BASEARCH=$archivos->{arg}->{$elemento}->[1];
      #$archi=File::Spec->catfile($BASEARCH,$archi.".gnu");


      if (defined $mensajegra->{$grafo}) {
          $mens = "\"$mensajegra->{$grafo}\"";
          if ($hacearch){
	      print $DIBUJAR "echo $mens\n";	      
	      }
      
         #print  $DIBUJAR  'cd -P $DIR ',"\ncd $rel\n";
         #print  "gnuplot $archi\n";
         }
      
      if ($nomostrar->{$grafo}) {
	  $paraarchivos.="gnuplot $archi >/dev/null\n";
	  $paraver.="$archi NULL\n";
          if ($hacearch){
	      print $DIBUJAR "gnuplot $archi >/dev/null\n";
	      }
      } else {
	  $paraarchivos.="gnuplot -persist $archi\n";
  	  $paraver.="$archi\n";
          if ($hacearch){
  	      print $DIBUJAR "gnuplot -persist $archi\n";
	      }
      }
      if ($hacearch){
	  print $DIBUJAR "RCODE=\$RCODE\$?\n";
          }
  };
  if ($hacearch){
    print $DIBUJAR "exit \$RCODE\n";
    close $DIBUJAR;
    chmod 0755, $archivo;
    }  

  # no se que es esto!!!
  my @grafos = sort keys %$noarchresori;
  if (@grafos) {  
      my $mens = ' ' x 15 .
            "guardar $simbografori{$grafos[-1]} = $guardar_graf->{$grafos[-1]}\n";
      explic(" Ud. puede elegir nombres para los archivos que
                   guardarán los gráficos, agregando al cuadro GRAFICOS
		   renglones similares a: (para opción por defecto)\n"
           . $mens);
      };    

  
  return ($archivo,$archivosingra,$paraarchivos,$paraver);
  #system "chmod a+x $archivo";
  Simusol::AyudasPP::comfin('fin dibu');
}
# -----------------------------------------------------------------------------
sub contr{
   my ($plf,$pun_lin)=@_;


  Simusol::AyudasPP::comfin('com contr'); # no tiene argumentos
  # controla relacion entre grafos y los archivos que los contendran
  for my $grafo (sort keys %exigraf){
      my %funfun; $funfun{$grafo} = [];
      foreach my $reff (@{$fun{$grafo}}) {
          my @lisf = @$reff;
          @lisf > 2 and avnoseent("funcion @lisf; se ignora");
          @lisf == 2 and 
               push @{$funfun{$grafo}},"$lisf[0] title \'$lisf[1]\'";
          @lisf == 1 and 
               push @{$funfun{$grafo}},"$lisf[0]";         
          };
      $plf->{$grafo} = join (",\\\n", @{$pun_lin->{$grafo}}, @{$funfun{$grafo}}); 
      if ($plf->{$grafo} eq '' and $mj{$grafo} eq '') {
          $exigraf{$grafo} = 0;
          next;
      } elsif ($plf->{$grafo} ne '' and $mj{$grafo} ne '') {
          avnograv("No son posibles los pedidos para $simbografori{$grafo};
        resultan incompatibles:
            $plf->{$grafo}   
            mostrarjuntos  $mj{$grafo}.........
        Se ignorarán");
	  $exigraf{$grafo} = 0;
	  next
      };
    # movido a dibu  # ABSURDO MOVERLO Y ABSURDO QUE ESTE ACA, si no esta es porque el GNU NO FUE CREADO!!!
    #  my $archi = $guardar_graf->{$grafo}; 
    #  if (not defined $archi) {
    #      $guardar_graf->{$grafo} = $PROPIOASIN . "_$grafo";
    #      $noarchresori->{$grafo} = 1;
    #  };
  };
  #my @grafos = keys %noarchresori;
  #if (@grafos) {  
  #    my $mens = ' ' x 15 .
  #          "guardar $simbografori{$grafos[-1]} = $guardar_graf->{$grafos[-1]}\n";
  #    explic(" Ud. puede elegir nombres para los archivos que
  #                 guardarán los gráficos, agregando al cuadro GRAFICOS
#		   renglones similares a: (para opción por defecto)\n"
 #          . $mens);
  #};    
  Simusol::AyudasPP::comfin('fin contr');

}# contr

##################################################################################
sub guardar_renglones{#REVISAR
  my ($refpedidos,$archivos,$elemento,$noclasXXX,$plf,$pun_lin,$nombrearch,$graff)= @_;


  #sacar noclas hasta de gnuplot

  my $cambiosenlosarch={};

  #print Dumper [@pedidos];
  
  Simusol::AyudasPP::comfin('com guardar_renglones',@_);
  # interpreta y guarda cada renglon (ampliado) de pedido de puntos o lineas
  # nombre simbólico de archivo en mayúsculas;
  # nombre simbólico de gráfico en minúsculas
  # Los guarda en @puntoslineas,  %archres, %variaciones;

  my @pedidos=@$refpedidos;
  map(s/(\W)CALCULADO/$1SIMULADO/,@pedidos); 
  my @SIMULADOs; map(do{/\W(SIMULADO\w+)/ and push(@SIMULADOs,$1)},@pedidos);
  my $reg_arch = 
   'archivo|variable|magn|indice|sceptre|todo|unidad|selec|unipri'
     . '|variacion|arch_var';
  my $reg_graf = '(titulo|eje|guarda|mostrarjunto|eco|rangox|rangoy)';
  my $reg_graf_arch = '(punto|linea|funcion)';
  my $reg_obsoletos = '(crear|extension)';
  my $reg_varios = 'nomostrar';
  my @pedidos_arch = grep(/^($reg_arch)/i,@pedidos);
  my @pedidos_graf = grep(/^($reg_graf)/i,@pedidos);
  my @pedidos_graf_arch = grep(/^($reg_graf_arch)/i,@pedidos);
  my @pedidos_obsoletos = grep(/^($reg_obsoletos)/i,@pedidos);
  my @pedidos_varios = grep(/^($reg_varios)/i,@pedidos);
  @pedidos_arch + @pedidos_graf + @pedidos_graf_arch + @pedidos_varios ==
    @pedidos or do {
	my @pedidoserror = grep(do{ not
        /^$reg_arch|$reg_graf|$reg_graf_arch|$reg_obsoletos|$reg_varios/}
         , @pedidos);
	avnoseent("los pedidos\n" . join("\n       ",@pedidoserror));
  };
  foreach my $pedido (@pedidos_arch) {
      my $renglon = $pedido;
      $renglon =~ s/^ +//;
      my $comando ='';
      my ($reflistai,$sepa,$reflistad,$listad) = Simusol::AyudasPP::parser($renglon);

  

      #print "PARSER  $listad ", Dumper $reflistai,$reflistad;
      
      # @separadores tiene exactamente tres elementos: inicial ,medio, final
      #que son identif. para patrones
      $reflistai  eq 'error' and do{ 
          avnoseent("$pedido\n         como pedido de gráfico ");next;
      };
      my ($descrip,$simbolo) = @$reflistai;
      $descrip =~ /^($reg_arch)/i;
      $comando = "A_$1"; 
      $SIMBOARCHORI{uc($simbolo)} = $simbolo
	  if not defined $SIMBOARCHORI{uc($simbolo)};
      $simbolo = uc($simbolo); 
      if ($comando eq 'A_variacion') {
          push @{$refparap{$simbolo}->{variaciones}}, $reflistad;
      } elsif ($comando eq 'A_arch_var') {
          push @{$refparap{$simbolo}->{arch_var}}# en guardar_renglones
	  , $reflistad;
	  #print "WWWW ", Dumper $reflistad;
	  
	  push @{$nombrearch->{$simbolo}}, $reflistad->[0];
          foreach(my $i = 1; $i < @$reflistad; $i ++) {
	      push @{$nombrearch->{$simbolo ."_$i"}}, $reflistad->[$i];
          };
     } elsif ($comando eq 'A_unipri') {
          $unipri{$simbolo} = $listad;  
      } elsif ($comando eq 'A_archivo') {
           push @{$nombrearch->{$simbolo}}, $listad;
      } elsif ($comando eq 'A_variable') {
          @{$refvarori{$simbolo}} = @$reflistad;   
          for (my $i=1;$i<@$reflistad+1; $i++) {
              $reflistad->[$i-1] eq '_' and $reflistad->[$i-1] = "col_$i";
          };
          $refparap{$simbolo}->{variables} = $reflistad;
      } elsif ($comando eq 'A_magn') {
          $refparap{$simbolo}->{magnitudes} = $reflistad;
          map(do{$_='' if $_ eq '_'},@$reflistad);
      } elsif ($comando eq 'A_indice') {
          $refparap{$simbolo}->{ind} = $reflistad;
      } elsif ($comando eq 'A_sceptre') {
          $refparap{$simbolo}->{sceptrevars} = $reflistad;
      } elsif ($comando eq 'A_selec') {
          push @{$selec{$simbolo}}, $reflistad;
      } elsif ($comando eq 'A_unidad')  {
	    $refparap{$simbolo}->{unidades} = $reflistad;  # puesto por dsa
          if ($listad =~/:/) {
              mejorar($renglon,$nombrearch,$archivos,$elemento); #no hace nada para este proceso,
              # pero escribe, si hace falta,  un archivo traducido
              # que usará después
          };    
        };
  };


  #print Dumper $archivos;
  #exit;
  #my $basearch=$archivos->{arg}->{$elemento}->{dirs}->[1];

  #print Dumper  \%refparap;
  #exit;


  
  # aqui relativo al paraplot o el archivo fuente que lo cita
  #no es necesario saber donde esta el simul para leeerlo, luego se debe decir donde relativo al gnu, no al gnu, sino al arch que ejecuta el gnu

  #print "CCC ", Dumper $nombrearch;
#  exit;


 
#  print Dumper $archivos;
#  print Dumper $nombrearch;

  foreach my $k (sort keys %$nombrearch){
      my @W=();
      my @WW=();  
           
      foreach (@{$nombrearch->{$k}}){

	  #print "NOM $_ \n";
	  my $dirpara=$archivos->{arg}->{$elemento}->{paraplot}->{dir};
          if (not defined $dirpara){ # 
	      $dirpara=$archivos->{arg}->{$elemento}->{dirs}->[1];
	      my $esta=$archivos->{arg}->{$elemento}->{dirs}->[4];

	      $archivos->{arg}->{$elemento}->{paraplot}->{esta}=$esta;
	      $archivos->{arg}->{$elemento}->{paraplot}->{dir}=$dirpara;	     	     
	      }
          my $EE;
          my $EEE;
	  my $a=file($_);

	  #print "ABSOLUTE $_";
	  #exit;
	  
	  my $R;
	  my $RR;
          if (not $a->is_absolute) {
	 
  	   #my ($ok,$EE,$dirdondesta)= buscasimul($_,$archivos,$elemento);  # busca simul o archivos datos para graficos 
	   # si son simul busca mas
           #if (not $ok){
   	   #die "No encontre simul: $_ , $EE\n";
           #};
	   # debo buscar relativo a cwd a partir de paraplot, porque no se si paraplot es mi fuente o viene de caj
           # esto vale si escribi el paraplot, si no no esta  	  

          if ($dirpara){
	      $EE=file($dirpara,$_);
	  }else{
	      $EE=file($_);
	      }
          #print "ZZZZZZZZZZZZZZZZZZZ $EE - $_ - $dirpara\n";
	
          eval {
	      $EEE=$EE->resolve;
	  };
         
	  if ($@){
	      warn "ERROR, los archivos a procesar indicados en el origen generico $elemento no existen,
 ARCHIVO $EE NO EXISTE: $@ \n"; #-  @_\n";
              #exit;
	      $EEE='';
	      return (-1);
	  }
          #print "ZZZZZZZZZZZZZZZZZZZ2  $EEE \n";
	  $R="$EEE"; # relativa ("$EEE",$dirdondesta);   #ala fuente - paraplot
  	  $RR= Simusol::AyudasPP::relativa("$EEE",$archivos->{arg}->{$elemento}->{gra}->{dirarchivo}); #al futuro gnu

	  $archivos->{arg}->{$elemento}->{simul}->{$EEE}->{relgra}=$RR;
	  

	 }else{
	     $EE=$_;
	     $EEE=$_;
	     $R=$_;
	     $RR=$_;
	 }
         $cambiosenlosarch->{"$RR"}="$EEE";
	  
          #print "RRR R $R, EE $EEE, RR $RR -origen: $_ -$archivos->{arg}->{$elemento}->{dirs}->[1] - $archivos->{arg}->{$elemento}->{gra}->{dirarchivo} \n";
          push (@W,"$EEE");
          push (@WW,$RR);
          }
      $nombrearch->{$k}=[@W];
      $archivos->{arg}->{$elemento}->{gra}->{nombresimul}->{$k}=[[@WW],[@W]];
  }

  #print Dumper $archivos->{arg}->{$elemento}->{gra}->{nombresimul};
  #exit;
  #print Dumper $nombrearch;
  #exit;
#  print Dumper $archivos;
 # print Dumper $nombrearch;
  
  
  impr_debug(__LINE__.' sim3 %SIMBOARCHORI',\%SIMBOARCHORI);
  impr_debug(__LINE__.' sim3 %$nombrearch',Dumper $nombrearch);

 
 # print Dumper  \%refparap{SIMULADO}->{arch_var};
  

  #print "cambios en los archs ", Dumper  $cambiosenlosarch;

#  foreach my $SE (sort keys %refparap){
#    if (defined $refparap{$SE}->{arch_var}){
#    my $cant = scalar @{$refparap{$SE}->{arch_var}};
#    foreach (0..$cant-1){
#	my $x=$refparap{$SE}->{arch_var}->[$_];
#	if (exists $cambiosenlosarch->{$x} ){
#          print "$_ - $cant - $x - $cambiosenlosarch->{$x}\n ";
#          $refparap{$SE}->{arch_var}->[$_]=$cambiosenlosarch->{$x}
#	}
#      }
#    print Dumper  $refparap{$SE}->{arch_var};
#    }


  # print "DDD ", Dumper  \%refparap;

  foreach my $SE (sort keys %refparap){
    #print "SE $SE\n";
    if (defined $refparap{$SE}->{arch_var}->[0]){
    my $cant = scalar @{$refparap{$SE}->{arch_var}->[0]};
    foreach(0..$cant-1){
      my $x=$refparap{$SE}->{arch_var}->[0]->[$_];
      #print "$x - $cambiosenlosarch->{$x}\n ";
      # si no esta a veces esta variable no esta definida
      $refparap{$SE}->{arch_var}->[0]->[$_]=$cambiosenlosarch->{$x}
      }

   }
   
   ###   exit;
      
 }
  #exit;

  #print "XXXXXXXXXXX2a ", Dumper \%refparap;
  
  my $refarchposibles = leer_info_archivos([sort keys %SIMBOARCHORI],$nombrearch);


      
  #print "XXXXXXXXXXX2 ", Dumper \%refparap;

 #  print "XXX ", Dumper \%refarch,  \%refparap;
  
  my $refparposibles = contr_archivos_paraplot($refarchposibles,$nombrearch,$archivos->{arg}->{$elemento}->{dirs}->[4]);

#  print "XXXXXXXXXXX ", Dumper \%refparap;
#  print "XXX ", Dumper \%refarch;

# print "XXX2 ", Dumper \%refarch,  \%refparap;
  
  completar_nombres($refparposibles,$graff) if @$refparposibles;

 
  
  contr_sobre_archivos($refparposibles,$nombrearch,$archivos->{arg}->{$elemento}->{dirs}->[4],$archivos,$elemento);   # aqui tambien arch_var = contr_variac

  #los que tienen SIMULADO como parte de su nombre

  foreach my $pedido (@pedidos_varios) {
      my $renglon = $pedido;
      if ($renglon =~ s/^\s*nomostrar\s+([^=]+)$/$1/i) {
          $renglon =~ s/\s*$//;
          my @nolista = split ('\s*,\s*',$renglon);
          map( $nomostrar{lc($_)} = 1, @nolista); 
      }; 
  };
  if (@pedidos_obsoletos) {
      avnograv('Los  pedidos "crear" o "extension" son obsoletos;
                los archivos de extension ".png" se producen siempre');
  };
  my @listagrafos;
  map (do{/^\w+\s+(\w+)/ and push @listagrafos,lc($1)}
       ,(@pedidos_graf, @pedidos_graf_arch));


  my $guardar_graf={};                 # le agrega en contr_graf y mas adelante aca
  
  contr_graf(\@listagrafos,$guardar_graf,$archivos,$elemento,$plf,$pun_lin);   # usa propioasin para guardar en un hash info sobre donde grabar archivo


  
  foreach my $pedido (@pedidos_graf, @pedidos_graf_arch ) {
      my $renglon = $pedido;
      $renglon =~ s/^ +//;
      my ($comando,$mens) = ('','');
      my ($reflistai,$sepa,$reflistad,$listad) = parser($renglon);
      # @separadores tiene exactamente tres elementos: inicial ,medio, final
      #que son identif. para patrones
      $reflistai  eq 'error' and  
         avnoseent("el pedido  para graficar
                   $pedido");
      my ($descrip,$simbolo) = @$reflistai;
      $descrip =~ /^($reg_graf)/i or $descrip =~ /($reg_graf_arch)/i; 
      $comando = "g_$1";
      $simbolo = lc($simbolo); 
      if ($comando eq 'g_titulo'){$titulograf{$simbolo} = $listad;
      } elsif ($comando eq 'g_rangox') {$rx{$simbolo} = rango($listad);
      } elsif ($comando eq 'g_rangoy') {$ry{$simbolo} = rango($listad);
      } elsif ($comando eq 'g_funcion') {push @{$fun{$simbolo}}, $reflistad;
      # gnuplot le pone como título la definición de la función; salvo
      #que se le de un título
      } elsif ($comando eq 'g_guarda') {
          if ( @$reflistad == 1) {
              $guardar_graf->{$simbolo} = $reflistad->[0];
              $guardar_graf->{$simbolo} = $reflistad->[0];
          } else {
           avnoseent("el pedido de guardar
                     $pedido");
          }
      } elsif ($comando eq 'g_eje') {
          my ($coderr,@lisd) = juntar_por_paren(',',@$reflistad);
          if (@lisd != 2) {
              avnoseent(join(',',@lisd) . " como parte de indicación para ejes
                   pueden resultar gráficos erroneos
          Se espera, por ej.,  \"ejes xxxx = tiempo(seg), temp(grados C)\"");
          } else {
              $titx{$simbolo} = $lisd[0];# por eje
              $tity{$simbolo} = $lisd[1];# por eje
              (my $varabsc,$uniabscisa{$simbolo})
                   = extraer($lisd[0]); # por eje
              (my $magord,$uniordenadas{$simbolo}) 
                   = extraer($lisd[1]);#por eje
          };
      } elsif ($comando eq 'g_punto' or $comando eq 'g_linea') {
#	  impr_debug(__LINE__.' sim3 $listad',$listad);
	  my @listad = split /\s*[,:]\s*/,$listad;
	  if (@listad >= 3) {
              my $simbarch = uc(shift @listad); my $exi = $exiarch{$simbarch};
	      if (not defined $exi or $exi < 2) {
                  avnoseent("el pedido: $pedido  
                  usa archivo de nombre simbolico $simbarch no declarado");
	      } else {
		  my $cols = join ',',@listad;
#		  my $simbarchp = ($archivopadre->{$simbarch} or $simbarch);
                  my ($refbuenas,$refmalas) 
		      = contr_graf_arch_cols($simbolo, $simbarch, $cols,$graff);
		  if (@$refmalas == 0) {
                      push @{$usagraf_coma_arch_cols{$simbolo}}
                        , [$comando, $simbarch, $refbuenas] if @$refbuenas >1;
                  }; 
             };
          } else {
	      impr_debug(__LINE__.' sim3 $comando $listad'
			 ,[$comando,'||',$listad]);
              avnoseent("el pedido del gráfico \"$simbolo\":
                  $pedido");
          };
      } elsif ($comando eq 'g_mostrarjunto'){
          if (defined $juntos{$simbolo}){ 

#and
#               Simusol::AyudasPP::parar3(40,
#              "En la informacion de paraplot hay más de una sentencia
#                mostrarjuntos $simbolo");

	      warn "En la informacion paraplot hay más de una sentencia mostrarjuntos $simbolo,";
	      warn join  ("\n",@pedidos);
	      warn Dumper \%juntos;
	      
	  # decia archivo y su nombre, pero resulta que ahora no hay necesariamente archvio paraplot,
	  # poner nombre leido en linea de comando para identificar el error, sea paraplot o caj o lo que sea
	  exit;
	  }


	  
          $juntos{$simbolo} = $reflistad;
          map($_ = lc($_),@$reflistad); 
          push @mostrarjunto, $simbolo;
          $mj{$simbolo} = '(' . join (',',@$reflistad) .')';       
      } elsif ($comando eq 'g_eco') {
          $pedido =~ s/^[^=]+=//;
          $mensajegra{$simbolo} .= "$pedido\n";
     };
  };
  impr_debug(__LINE__.' sim3 %usagraf_coma_arch_cols'
	     ,Dumper \%usagraf_coma_arch_cols);


  return(1,$guardar_graf);

  Simusol::AyudasPP::comfin('fin guardar_renglones');
}# guardar_renglones   
# -----------------------------------------------------------------------------

sub rango{
  use warnings  FATAL => qw(numeric uninitialized);
  my $rango = $_[0]; my ($uno,$dos); my $dif = '';
  if (($uno,$dos) = $rango =~ /^\s*(\S*)\s*:\s*(\S*)\s*$/) {
      $uno ne '' and $uno = eval($uno);
      $dos ne '' and $dos = eval($dos);
      $uno ne '' and $dos ne '' and $dif = eval($dos-$uno);
      (defined $uno and defined $dos and defined $dif 
        and ($dif eq '' or $dif > 0)) 
        or do{
            avnoseent("$rango para indicar un rango");
            return '';
        };	   
      return "[$uno:$dos]"
  };  
  avnoseent("$rango para indicar un rango");
  return '';  
}# rango    
# -----------------------------------------------------------------------------
sub mejorar{
  Simusol::AyudasPP::comfin('com mejorar',@_);
  #copia un archivo sobre otro xxxx.mejor, 'mejorandolo'
  my ($renglonant,$nombrearch,$archivos,$elemento) = @_;
  if (not $renglonant =~ /\s*(\S+)\s*=\s*(.+)/ ) {
      return;
  } else{
      my  ($simbarch, $resto) = ($1, $2);
      my $nomarch = $nombrearch->{$simbarch}->[-1];

      ($resto !~ /yy.mm.dd/i and $resto !~ /hh.mm.ss/i) and return; 
      my @listunis = split(/\s*,\s*/,$resto);
      my (%funcion,@ies)=();my $salto = 24 * 3600;my $ii;
      for (my $i = 0; $i < @listunis; $i++)  {
          if ($listunis[$i] =~ /hh.mm.ss/) {
              $funcion{$i} = '$x1 * 3600 + $x2 * 60 + $x3 ';
	      push(@ies,$i);$ii=$i;$listunis[$i] = 'segundos';
	      last; 
              #REVISAR no se espera mas que un $ii	    
	  };
      };
      my $nommejor = $nomarch . '.mejor';
      $nombrearch->{$simbarch}->[-1] =  $nommejor;
      my @listanomarch = stat($nomarch);
      my ($renglon,@listaval,$resul, $resulant);
      if (-e $nommejor) {
          my @listanommejor = stat($nommejor);  
          if ($listanomarch[9] 
	        and $listanomarch[9] gt $listanommejor[9] ) { 
          } else {
              explic("El archivo $nommejor es posterior al $nomarch
            No se recalcula; se usa el existente; "); 
              return;
	  };
      };
      if (not -e $nomarch) {
	    my $DIRC=getcwd();
          avnograv(__LINE__." No existe el archivo $nomarch; dir: $DIRC
            no se puede preparar el $nommejor");
          return 105;
      }; 
      mensaje ("Archivo $nommejor; lo crearemos ahora a partir del $nomarch");
      my $ARCHDAT;
      open ($ARCHDAT,$nomarch);
      Simusol::AyudasPP::archiva($nommejor,'F',$archivos,$elemento);
      my $ARCHDATMEJOR;
      open ($ARCHDATMEJOR,">$nommejor") or die "No puedo crear $nommejor (3)\n";       ### NUNCA GRABO ACA
      $renglon = <$ARCHDAT>;
      my $sigue = 1;
      while ($sigue and $renglon =~ /\s*\#/ ) {
          $renglon = <$ARCHDAT>;
	  $sigue = 0 unless $renglon;
      };	  
      @listaval = split(/\s+/,$renglon);
      interpr_hhmmss(\@listaval,$ii,\%funcion);
      $resul = $listaval[$ii];      
      $salto = - $resul;
      $listaval[$ii] = 0;$resulant = $resul;
      impre_renglones(\@listaval);
      while ($renglon = <$ARCHDAT>) {
	  next if $renglon =~ /\s*\#/;
	  next if $renglon =~ /^\s*$/;
          @listaval = split(/\s+/,$renglon);                  
	  interpr_hhmmss(\@listaval,$ii,\%funcion);
	  $resul = $listaval[$ii];
	  if ($resul < $resulant) {
              $salto += 24*3600;
	  }; 
	  $listaval[$ii] = $resul + $salto;
	  $resulant = $resul;
	  impre_renglones(\@listaval)
      }
      close ($ARCHDATMEJOR);
     close($ARCHDAT);
  };
  
}
# -----------------------------------------------------------------------------
sub impr_grafo{
  $Data::Dumper::Indent = 0;
  my ($grafo,$mensaje,$guardar_graf,$plf) = @_;
  my $grafotext = "impr_grafo: $mensaje                       $grafo\n";
  if ($juntos{$grafo}) {
      $grafotext.=' ' x 10 . "\$juntos{$grafo} = @{$juntos{$grafo}}\n";
      return;
  };
  $grafotext.=' ' x 10 . '$titx '. $titx{$grafo} .' $tity '."$tity{$grafo}\n";
  $grafotext.=' ' x 10 . '$rx '. $rx{$grafo} .' $ry '. "$ry{$grafo}\n";
  $grafotext.=' ' x 10 . '$usagraf_coma_arch_cols '
      . Dumper($usagraf_coma_arch_cols{$grafo})."\n";
  $grafotext.=' ' x 10 . 'guardar_graf '. "$guardar_graf->{$grafo}\n";
  if ($plf->{$grafo}) {
      $grafotext.=' ' x 10 . '%plf '.  $plf->{$grafo}."\n"  if $plf->{$grafo};
  } else {
      $grafotext.=' ' x 10 . '$mj '. "$mj{$grafo} \n";
      $grafotext.=' ' x 10 . '%uniabsc '. Dumper($uniabsc{$grafo})."\n" ;
      $grafotext.=' ' x 10 . '%varabsc '. Dumper($varabsc{$grafo})."\n";
      $grafotext.=' ' x 10 . '%uniord '. Dumper($uniord{$grafo})."\n" ;
      $grafotext.=' ' x 10 . '%magord '. Dumper($magord{$grafo})."\n" ;
      $grafotext.=' ' x 10 . '%prig '. Dumper($prig{$grafo})."\n" ;
      $grafotext.=' ' x 10 . '%segg '. Dumper($segg{$grafo})."\n" ;
      $grafotext.=' ' x 10 . '$uniabscisa '. "$uniabscisa{$grafo}\n" ;
      $grafotext.=' ' x 10 . '$uniordenadas '. "$uniordenadas{$grafo}\n" ;  
  };
  $Data::Dumper::Indent = 1;
  impr_debug(__LINE__.' sim3',$grafotext);
}#impr_grafo
# -----------------------------------------------------------------------------
sub impre_renglones{
    my $reflistaval=$_[0];
    foreach (@$reflistaval) {
        printf ARCHDATMEJOR  "%7s ", $_;
    }
    print ARCHDATMEJOR  "\n";
}# impre_renglones
# -----------------------------------------------------------------------------
sub interpr_hhmmss{
   my ($reflistaval,$ii,$reffun) = @_;
# por ahora solo tiene sentido una columna de valores de tiempo  hh:mm:ss 
          my $resul;
          my $valin = $reflistaval->[$ii];
	  $valin =~ /(.{1,2}).(..).(..)/ 
	        or die 'simusol3.pl: interpr_hhmmss: que pasa ';
	  my ($x1,$x2,$x3) = ($1,$2,$3);
	  $resul = eval ($reffun->{$ii});
	  $reflistaval->[$ii] = $resul;
}# interpr_hhmmss
# -----------------------------------------------------------------------------
sub leer_paraplot3{
 my ($reng,$elemento,$archivos,$noclas, $plf,$pun_lin,$nombrararch,$graff) = @_; 
 Simusol::AyudasPP::comfin('com leer_paraplot3',@_);
 
 # BASEARCH esta bien aca y abajo, sirve para agregar a los archivos simul el camino correcto

 # cada ds caj o paraplot trae el suyo y se resuelve donde llaman a leer_paraplot
 # print "RRR @renglones";
 # exit;
 my @renglones=@$reng;

  map(s/\#.*//, @renglones); 
  @renglones = grep (/\S/,@renglones);
  my @renglonespegados;  
  while (@renglones) {
      my $renglon = shift @renglones; 
      next unless $renglon =~ /\S/;
      $renglon =~ s/^\s+//; $renglon =~ s/\s+$//; $renglon =~ s/\s+=\s+/=/;
      my $pega =' ';
      $pega = "\n" if $renglon =~ /^\s*eco/;
      while (@renglones and $renglones[0] !~ /^[\s\w]+=/ 
             and $renglones[0] !~ /^\s*nomostrar/i
             and $renglones[0] !~ /^\s*crear/i   #obsoleto
             and $renglones[0] !~ /^\s*extensi/i #obsoleto
            ) {                
          $renglon .= "$pega$renglones[0]";
          shift @renglones;
      }; 
      push @renglonespegados, $renglon;
  };
 # impr_debug(__LINE__.' sim3 @renglonespegados',Dumper \@renglonespegados);

    
 my ($ok,$guardar_graf)=guardar_renglones(\@renglonespegados,$archivos,$elemento,$noclas,$plf,$pun_lin,$nombrararch,$graff);
 if ($ok != 1){return ($ok)}

   
 #print Dumper $guardar_graf;
 
  #  impr_debug(__LINE__.' sim3 %SIMBOARCHORI',\%SIMBOARCHORI);
  foreach my $ARCHIVO (sort keys %SIMBOARCHORI) {
      my $refparapARCH = $refparap{$ARCHIVO};
      if (not defined $refparapARCH->{variaciones} and
          defined $refparapARCH->{arch_var} ) {
	  my @lista = (); my @listaarch = @{$refparapARCH->{arch_var}};
          for (my $j = 0; $j < @listaarch; $j++) {
	      push @lista, "($j)";
          };
          $refparapARCH->{variaciones} = [@lista];
      };
  }; 


# MEJORT PONER EN GUARDAR RENGLONES
  my $propiosin=$archivos->{arg}->{$elemento}->{dirs}->[0];
 my $renglon;
 my @lisarchsimul;
 # $renglon = `grep "arch_var SIMULADO" $propiosin.paraplot`;
  #  "$propiosin.paraplot";
  #chomp $renglon;
 # OJO VER QUE PUEDE TENER BASEARCH ANTES AHORA
 
 # esto es una locura, ver que hace y para que!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 foreach my $renglon (@renglones){
   if ($renglon =~ s/^arch_var SIMULADO = $propiosin.simul\,//){
       @lisarchsimul = split ',', $renglon;
       last;
   }
 }
 return (1,\@lisarchsimul,$guardar_graf);

 

 
  Simusol::AyudasPP::comfin('fin leer_paraplot3 keys %exiarch %exigraf', keys %exiarch, ' ',keys %exigraf);
}#leer_paraplot3
# -----------------------------------------------------------------------------
sub sanear { #saca espacios y pone mayusculas
    my $col = $_[0];
    $col =~ s/\s*//g; 
    return uc($col);
}
# -----------------------------------------------------------------------------
sub seleccionar_filas{#selecciona_filas
  Simusol::AyudasPP::comfin('com seleccionar_filas',@_);  
  my ($SELEC_ARCHIVO,$llista,$archivos,$elemento) = @_;
  my @lista=@$llista;
  impr_debug(__LINE__.' sim3',\@lista);
  my $archp = shift @lista; 
  impr_debug(__LINE__.' sim3 nombarch',Dumper \%nombarch);
  my $nombre_real_padre = my $selec_nombrereal = $nombarch{$archp};
  impr_debug(__LINE__.' sim3 $selec_nombrereal',$selec_nombrereal);
  my $colo = shift @lista; my ($minimo,$maximo) = @lista;
  my $col = $refnombreshashes->{$archp}->{sanear($colo)};
  defined $col or do{avnoseent("$colo  en @lista"); return};
  $col = $refparap{$archp}->{ind}->[$col-1];
  @lista == 2  and do{
      $minimo <= $maximo or swap($minimo,$maximo);
  } or do{
      avnoseent("Sintaxis incorrecta, seleccionar $SELEC_ARCHIVO = @lista");
      return;
  };
  my $agre = '_'.lc($colo)."_$minimo"."_$maximo";
  $selec_nombrereal =~ s/\.simul/$agre.simul/;
  $nombarch{$SELEC_ARCHIVO} = $selec_nombrereal;
  impr_debug(__LINE__.' sim3 %nombarch',Dumper \%nombarch);
  my $selec_marca = '('.lc($colo) ."=$minimo:$maximo".')';
  $marca{$selec_nombrereal} = $selec_marca;
  impr_debug(__LINE__.' sim3 %marca',Dumper \%marca);
  Simusol::AyudasPP::archiva($selec_nombrereal,'F',$archivos,$elemento);
  my $NUEVO;
  my $VIEJO;
  open $NUEVO, ">$selec_nombrereal" or die "No puedo crear $selec_nombrereal (4)\n";
  open $VIEJO, $nombre_real_padre;
  my @listaval;
  my $cuantos;
  while (<$VIEJO>) {
      /\s*\#/ and do{print NUEVO $_;next};
     my $limpio = ''; my @listaval;
     if (/^\s*(\S.*)$/) {$limpio = $1};
     if ($limpio) {
         @listaval = split /\s*[\s\,]\s*/,$limpio;
         my  $key = $listaval[$col-1];
	 $key > $maximo and last;
         $minimo < $key  and 
             print NUEVO $_;
     };
     $cuantos ++;  
  };
  close $VIEJO; 
  close $NUEVO;
  explic("$cuantos renglones copiados"); 
  $archivopadre->{$SELEC_ARCHIVO} = $archp;
  $exiarch{$SELEC_ARCHIVO} = $exiarch{$archp};
  $nombarch{$SELEC_ARCHIVO} = $selec_nombrereal;
#  push @{$nombrearch->{"$SELEC_ARCHIVO"}}, $selec_nombrereal;
  Simusol::AyudasPP::comfin('fin seleccionar_filas');
  return;
}#seleccionar_filas
# -----------------------------------------------------------------------------
sub funciones{
  Simusol::AyudasPP::comfin('com funciones',@_);
  my ($grafo) = @_;
  my $funfun = [];
  foreach my $reff (@{$fun{$grafo}}) {
      my @lisf = @$reff;
      @lisf > 2 and avnoseent("funcion @lisf; se ignora");
      @lisf == 2 and 
           push @{$funfun},"$lisf[0] title \'$lisf[1]\'";
      @lisf == 1 and 
           push @{$funfun},"$lisf[0]";         
  };
  Simusol::AyudasPP::comfin('fin funciones',@$funfun);
  return $funfun;
}
# -----------------------------------------------------------------------------
sub pun_lin{
  Simusol::AyudasPP::comfin('com pun_lin',@_);
  my ($grafo,$usagraf_coma_arch_cols, $archivopadre,$uniabscisa,$uniordenadas, $nombarch,$refparap,$pun_lin,$refvarori,$marca,$selec) = @_;
  
  foreach my $refrenglon (@{$usagraf_coma_arch_cols->{$grafo}}) {
     
      my ($comando,$ARCHIVO,$listacol)= @$refrenglon;
          
      my $ARCHIVOP = $archivopadre->{$ARCHIVO};

      defined $ARCHIVOP or $ARCHIVOP= $ARCHIVO;
      #print "REFRENGLON $comando,$ARCHIVO,$ARCHIVOP  XXX: @$listacol\n";

      my @listacol = @$listacol;  
      my ($pri,$titulo,$factorpri);
      $pri = shift @listacol; my $priajus = $pri;
      my $uniabscisa = $uniabscisa{$grafo};
      $priajus = ajustar_uni($ARCHIVOP,$uniabscisa,$pri) if $pri >0; 
      my $with; 
      $comando eq 'g_linea' and $pri > 0 and $with = ' with lines'
	  or $with = 'with points';


      # print "$priajus - $with\n";


      #print Dumper $nombarch;
      #print Dumper $selec;
      #print Dumper $refparap->{$ARCHIVO}->{arch_var};
      
      my %ajus;
      for (my $i = 0; $i < @listacol; $i ++) {
          $ajus{$listacol[$i]} = 
              ajustar_uni($ARCHIVOP,$uniordenadas->{$grafo},$listacol[$i]);
      };
      my $simbolosust = $nombarch->{$ARCHIVO};
      my @listasust; #my @marcas = ('');
      if ($selec->{$ARCHIVO}) {
	  @listasust = ($nombarch->{$ARCHIVO});
      } elsif (defined $refparap->{$ARCHIVO}->{arch_var} and scalar @{$refparap->{$ARCHIVO}->{arch_var}}) {
	  # no solo definido sino con contenido!
	  #print "lll MMM\n";
	  #print Dumper $refparap->{$ARCHIVO}->{arch_var};
	  # ojo puesto como parche ver porque, antes funcionaba
	  #print Dumper $refparap;
	  #exit;
          @listasust = @{$refparap->{$ARCHIVO}->{arch_var}};
      } else {
	  @listasust = ($nombarch->{$ARCHIVO});
      };

      #print "LLLL  @listasust\n";
      my $i = 0;
      foreach my $simbolosust (@listasust) {
	  #print "KKK $simbolosust\n";
          foreach my $seg (@listacol){
              my ($alguito,$titulo);
              $titulo =  "col_$seg";
              if (defined $refparap->{$ARCHIVOP}->{variables}) {          
                $titulo = $refvarori->{$ARCHIVOP}->[$seg-1] 
	      };
              $alguito = 
                 "'$simbolosust' using $priajus:$ajus{$seg} ";  
              defined $marca->{$simbolosust} or $marca->{$simbolosust} = ''; 
              $alguito .= "title '$titulo $marca->{$simbolosust}' $with";
              push @{$pun_lin->{$grafo}}, $alguito;
          }; # foreach $seg @listacol
          $i++;
       };# foreach  @listasust
  };# foreach @$usagraf_coma_arch_cols 
 Simusol::AyudasPP::comfin('fin pun_lin');
} #pun_lin
# -----------------------------------------------------------------------------
sub ajustar_uni{

   my ($ARCHIVO,$unigrafico,$indicevar) = @_;

   Simusol::AyudasPP::comfin('com ajustar_uni',@_);
    

    #our ($unidadtiempo ,$comitiempo, $fintiempo,$origcomitiempo,$origfintiempo) 
    #        =  ('minuto', 0, 10800, '0', '180 minuto'); 
    




   #$indice se refiere a variables propias, $indicesceptre a var.sceptre.
   #ambos a partir de 1;
   my $indicesceptre = $refparap{$ARCHIVO}->{ind}->[$indicevar-1];
   defined $indicesceptre or $indicesceptre = $indicevar;
   defined $unigrafico and $unigrafico eq '??' and return $indicesceptre; 
   my ($refu,$reffac) = ($refparap{$ARCHIVO}->{unidades}
                         , $reffactor{$ARCHIVO});
   my $unitarchivo = $datosPlotGNU->{unist}->{lc($refu->[$indicevar-1])};
   my $unitgrafico = $datosPlotGNU->{unist}->{$unigrafico};
   # %unist, con abreviaturas de unidades para tiempo
   # %factort facores para convertir unidades de tiempo
   my $fac = $reffac->[$indicevar-1]; #no se usa intencionalmente para Tiempo 
   $fac or $fac =1;
   #si $uniarchivo no esta definido, no se ha previsto ninguna conversion
   if (defined $unitarchivo && defined $unitgrafico &&
     defined($datosPlotGNU->{factort}->{$unitgrafico}) && defined($datosPlotGNU->{factort}->{$unitarchivo})) {
       $fac = $fac * $datosPlotGNU->{factort}->{$unitarchivo}/$datosPlotGNU->{factort}->{$unitgrafico}
   };
   Simusol::AyudasPP::comfin('fin ajustar_uni', $indicesceptre, $fac);
   $fac == 1 and return $indicesceptre
      or do{
          $fac = sprintf "%6.4g",$fac;
	  return  "\(\$$indicesceptre\*$fac\)"; 
   };
}# ajustar_uni



######################################



# ---------------------------------------------------------------------------
sub controlar_reserv_dirsVIE{
  comfin('comA controlar_reserv_dirs',@_);
  my ($ref,$crear) = @_;# $estedir con / fin
  my ($coderr,$mensaje) = ('','');
  my @reserv_dirs = (union_conjunto(values %dirsalida),'cprojects','cauxes');
#  impr_debug(__LINE__.' Auxi %dirsalida',Dumper \%dirsalida);
  impr_debug(__LINE__.' Auxi',[@reserv_dirs]);
  my $outdir = $ref->{outdir};
  foreach my $reservdir (@reserv_dirs) { 
      if ($outdir =~ /\/$reservdir\//) {
           $mensaje =  "   $outdir\n,       pasando por  $reservdir,
  no es buen lugar para recibir resultados; use adecuadamente la opcion outdir";
          $coderr = 254; last;
      };
  };
  $coderr and return ($coderr,$mensaje);    
  foreach my $estedir (@{$ref->{basearchcorto}}) {
#      impr_debug(__LINE__.' Auxi $estedir',$estedir);
      foreach my $reservdir (@reserv_dirs) { 
          if ($estedir =~ /\/$reservdir\//) {
              push @MENSAJES, "   $estedir\n,       pasando por  $reservdir,
  no es buen lugar para recibir resultados; use adecuadamente la opcion outdir";
          $coderr = 254; last;
          };
      };
  };    
  if (not $coderr and $crear) {
      ($coderr,$mensaje) = crear_subdirectorios($outdir,@reserv_dirs);
  };
  comfin('finA controlar_reserv_dirs',$coderr,$mensaje,$outdir);
  return $coderr,$mensaje;
}#controlar_reserv_dirs
# ---------------------------------------------------------------------------
sub crear_subdirectoriosVIE{
  comfin('comA crear_subdirectorios',@_);
  my ($desde, @subdirs) = @_;
  my $coderr = '';
  if (-e $desde and not -e $desde) {
      push @MENSAJES, 
        " Hay un archivo no directorio $desde que se ha pedido como directorio";
  } elsif (not -d $desde) {
      mkdir $desde;
      if (not -d $desde) {
	 push @MENSAJES," No existe y no se pudo crear el directorio $desde\n";
         $coderr = 253;
     };
  };
  if (not $coderr) {
      foreach my $subdir (@subdirs) {
          if (not -d "$desde/$subdir") {
              mkdir "$desde/$subdir";
              if (not -d "$desde/$subdir") {
                  push @MENSAJES
                    , " No existe y no se pudo crear el directorio $desde/$subdir\n";
              };
          };
      };
  };
  my $mensaje = textear_MENSAJES();    
  comfin('finA crear_subdirectorios',$coderr,$mensaje);
  return $coderr,$mensaje;
}#crear_subdirectorios;



#######################################

sub contr_graf_arch_colsVIE{

  my $graff; # MALLL  
  Simusol::AyudasPP::comfin('com contr_graf_arch_col',@_);
  #se ocupa de una pareja graf,arch en lo que tiene que ver preparando para 
  #titulos y conversion de unidades 
  my ($graf,$arch,$listacol) = @_; 
  my $archp = $archivopadre->{$arch}; #imprescindible si hubo seleccion
  defined $archp  or $archp = $arch;
  my $haycol = $refarch{$archp}->{colposibles};
  if ($graff > 1 and defined $refparap{$archp}->{variables}) {
      $haycol = @{$refparap{$archp}->{variables}}
  };
  #impr_debug(__LINE__.' sim3 $refnombreshashes',Dumper $refnombreshashes);
  my @cols = split /[\:\,]+/, $listacol;
  map(s/\s//,@cols);
  my @malascols;
  foreach (@cols) {
      next if /^\d+$/ and $_ <= $haycol;
      my $colori = $_;
      $_ ne '0' and $_ = $refnombreshashes->{$archp}->{sanear($_)};
      defined $_ or do{push @malascols, $colori; $_ = -1};
  }; 
  @malascols > 0  and do{
          avnoseent("el pedido del gráfico \"$graf\" de variables
          ".join (' ', @malascols )
                  ." para archivo de nombre simbólico $arch");
 
  };

  my $pricol = $cols[0];
  $pricol >= 0 and $pricol <= $haycol or do{
          avnoseent("el pedido del gráfico \"$graf\", de abscisa
             la columna $cols[0] del archivo de nombre simbólico $arch");
          return [], [@cols];
  }; 
  my @buenascols = grep (do{$_ <= $haycol and $_ >=  0}, @cols); 

      my @colsord = sort {$a <=>$b} (union_conjunto(@cols));
      my $ncol = $colsord[-1];

      my $unidad = $unipri{$archp};
      if (not defined $unidad) {
	  $unidad = $refparap{$archp}->{unidades}->[0];
      };
      if (defined $unidad and defined $datosPlotGNU->{unist}->{lc($unidad)} ){
          $unidad = $datosPlotGNU->{unist}->{lc($unidad)};
      };
      defined $unidad or $unidad = ''; 
  Simusol::AyudasPP::comfin('fin contr_graf_arch_col', $graf,$arch,@cols);
  return [@cols], [@malascols];
} #contr_graf_arch_col

########################
sub mostrar_juntos{  # UNIDO A GRAFEAR
 #   my ($noarchresori,$guardar_graf,$archivos,$elemento,$graff,$mensaje_comienzo)=@_;                                       # CREA GNU

    my ($h,$noarchresori,$guardar_graf,$archivos,$elemento,$plf,$graff,$mensaje_comienzo)=@_;                                       # CREA GNU

    # no se usa $plf pero para igualar con grafear
  Simusol::AyudasPP::comfin('com mostrar_juntos',@_);
  my $size = 1; $size = 0.7 if $graff eq '5';
  foreach my $grafj (sort keys %juntos) {
      defined $guardar_graf->{$grafj} or
      do {$guardar_graf->{$grafj} = $grafj;
          $noarchresori->{$grafj} = 1;
      };

    my $archivog;
    my $archi=$archivos->{arg}->{$elemento}->{$grafj}->{gnu};
    $archivog->{eps}=$archivos->{arg}->{$elemento}->{$grafj}->{releps};
    $archivog->{png}=$archivos->{arg}->{$elemento}->{$grafj}->{relpng};
    #print "GRAFO $grafo $archivoeps REL $archi, $guardar_graf->{$grafo}, X $archivos->{arg}->{$elemento}->{gra}->{dirarchivo} \n"; 

    #my ($archivoeps,,$x1,$x2)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.eps',$guardar_graf->{$grafj});
    #my ($archivopng,$x3,$x4)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.eps',$guardar_graf->{$grafj});
    #my ($archi,$x6,$x5)     =Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.gnu',$guardar_graf->{$grafj});
      
    #my $archik=relativa ($guardar_graf->{$grafj},$archivos->{arg}->{$elemento}->{gra}->{dirarchivo});
    #print "GRAFO $grafj $archivoeps REL $archik - $guardar_graf->{$grafj}\n";
  #################################################################
      
   #   my $archi=$guardar_graf->{$grafj};
      #   $archi.='.gnu';
      Simusol::AyudasPP::archiva($archi,'F',$archivos,$elemento); 
      open my $ESTE,">$archi" 
          or die "No puedo crear $guardar_graf->{$grafj} (5)\n";
      my @graf = @{$juntos{$grafj}};
      @graf = grep($exigraf{$_},@graf);
      if (@graf == 0) {
          $exigraf{$grafj} = 0;
          next;
      }; 
      print $ESTE "\# MOSTRAR_JUNTOS archivo $archi $mensaje_comienzo ";
      print $ESTE "$archi\n";
      print $ESTE "set term X11\nset size $size,$size\nset origin 0.0 ,0.0\n";
      my $multiplot = "set multiplot\nset lmargin 11\nset bmargin 1\n";
      print $ESTE "$multiplot";
      my $cuantos = scalar @graf;
      my $altura = $size*0.90/$cuantos; 
      my $textografo = '';
      for (my $i = 0; $i < $cuantos; $i ++) { #solo se espera $cuantos  2 
          my $grafo = $graf[$i];
          next if not defined $todo{$grafo};
          my $texto = "$todo{$grafo}";
          my @lista = split(/\n/,$texto); 
          my $yorigen = $size - ($i+1) * $altura;
          $textografo .= "set size $size,$altura\nset origin 0.0 ,$yorigen\n";
          foreach(@lista) {
	      next if /set xlabel/ and $i != $cuantos-1;
	      next if /set term/ ;
              last if /term postcript/;
              $textografo .= "$_\n"; 
          };
      };   
      print $ESTE $textografo;
      print $ESTE "set nomultiplot\n"
       ."reset\n";
      foreach my $tipograf ('eps','png') {
          print $ESTE "set term $datosPlotGNU->{term}->{$tipograf}\nset output \'$archivog->{$tipograf}\'\n";
          print $ESTE $multiplot, $textografo, "set nomultiplot
reset\n";
      };
      close($ESTE);				
#      my $impre =  
#   " Archivos asociados con  \"$simbografori{$grafj}\": $guardar_graf->{$grafj} ";
#      $impre .= "\n" . ' ' x 10 . 
#        "$guardar_graf->{$grafj}.eps   $guardar_graf->{$grafj}.png";
#      explic($impre);
      $exigraf{$grafj} = 1;      
  };
  Simusol::AyudasPP::comfin('fin mostrar_juntos');
} 

1;
